]>
Commit | Line | Data |
---|---|---|
1 | #!/bin/sh -- # no runable script, just for vi | |
2 | ||
3 | EXIT_CODE=0 | |
4 | ||
5 | while [ -n "$1" ]; do | |
6 | if [ "$1" = "-q" ]; then | |
7 | export MSGLEVEL=2 | |
8 | elif [ "$1" = "-v" ]; then | |
9 | export MSGLEVEL=4 | |
10 | elif [ "$1" = '--color=no' ]; then | |
11 | export MSGCOLOR='NO' | |
12 | elif [ "$1" = '--color=yes' ]; then | |
13 | export MSGCOLOR='YES' | |
14 | elif [ "$1" = '--color' ]; then | |
15 | export MSGCOLOR="$(echo "$2" | tr 'a-z' 'A-Z')" | |
16 | shift | |
17 | elif [ "$1" = '--level' ]; then | |
18 | export MSGLEVEL=$2 | |
19 | shift | |
20 | else | |
21 | echo >&2 "WARNING: Unknown parameter »$1« will be ignored" | |
22 | fi | |
23 | shift | |
24 | done | |
25 | export MSGLEVEL="${MSGLEVEL:-3}" | |
26 | ||
27 | # we all like colorful messages | |
28 | if [ "${MSGCOLOR:-YES}" = 'YES' ]; then | |
29 | if [ ! -t 1 ]; then # but check that we output to a terminal | |
30 | export MSGCOLOR='NO' | |
31 | fi | |
32 | fi | |
33 | ||
34 | ||
35 | if [ "$MSGCOLOR" != 'NO' ]; then | |
36 | CERROR="\033[1;31m" # red | |
37 | CWARNING="\033[1;33m" # yellow | |
38 | CMSG="\033[1;32m" # green | |
39 | CINFO="\033[1;96m" # light blue | |
40 | CDEBUG="\033[1;94m" # blue | |
41 | CNORMAL="\033[0;39m" # default system console color | |
42 | CDONE="\033[1;32m" # green | |
43 | CPASS="\033[1;32m" # green | |
44 | CFAIL="\033[1;31m" # red | |
45 | CCMD="\033[1;35m" # pink | |
46 | fi | |
47 | ||
48 | msgprintf() { | |
49 | local START="$1" | |
50 | local MIDDLE="$2" | |
51 | local END="$3" | |
52 | shift 3 | |
53 | if [ -n "$1" ]; then | |
54 | printf "$START " "$1" | |
55 | shift | |
56 | while [ -n "$1" ]; do | |
57 | printf "$MIDDLE " "$(echo "$1" | sed -e 's#^apt\([cfghs]\)#apt-\1#')" | |
58 | shift | |
59 | done | |
60 | fi | |
61 | printf "${END}" | |
62 | } | |
63 | msgdie() { msgprintf "${CERROR}E: %s" '%s' "${CNORMAL}\n" "$@" >&2; exit 1; } | |
64 | msgwarn() { msgprintf "${CWARNING}W: %s" '%s' "${CNORMAL}\n" "$@" >&2; } | |
65 | msgmsg() { msgprintf "${CMSG}%s" '%s' "${CNORMAL}\n" "$@"; } | |
66 | msginfo() { msgprintf "${CINFO}I: %s" '%s' "${CNORMAL}\n" "$@"; } | |
67 | msgdebug() { msgprintf "${CDEBUG}D: %s" '%s' "${CNORMAL}\n" "$@"; } | |
68 | msgdone() { msgprintf "${CDONE}DONE" '%s' "${CNORMAL}\n" "$@"; } | |
69 | msgnwarn() { msgprintf "${CWARNING}W: %s" '%s' "${CNORMAL}" "$@" >&2; } | |
70 | msgnmsg() { msgprintf "${CMSG}%s" '%s' "${CNORMAL}" "$@"; } | |
71 | msgninfo() { msgprintf "${CINFO}I: %s" '%s' "${CNORMAL}" "$@"; } | |
72 | msgndebug() { msgprintf "${CDEBUG}D: %s" '%s' "${CNORMAL}" "$@"; } | |
73 | msgtest() { msgprintf "${CINFO}%s" "${CCMD}%s${CINFO}" "…${CNORMAL} " "$@"; } | |
74 | msgpass() { printf "${CPASS}PASS${CNORMAL}\n"; } | |
75 | msgreportheader() { | |
76 | if [ -n "$MSGTEST_MSG" ]; then | |
77 | test "$1" != 'msgfailoutput' || echo | |
78 | if [ -n "$MSGTEST_MSGMSG" ]; then | |
79 | echo "$MSGTEST_MSGMSG" | |
80 | fi | |
81 | if [ -n "$MSGTEST_GRP" ] && [ "$MSGTEST_GRP" != 'NEXT' ] && [ "$MSGTEST_GRP" != "$MSGTEST_MSG" ]; then | |
82 | echo "${CFAIL}Part of the test group: $MSGTEST_GRP" | |
83 | fi | |
84 | echo -n "$MSGTEST_MSG" | |
85 | unset MSGTEST_MSG | |
86 | fi | |
87 | } | |
88 | msgskip() { | |
89 | msgreportheader 'msgskip' | |
90 | if [ $# -gt 0 ]; then printf "${CWARNING}SKIP: $*${CNORMAL}\n" >&2; | |
91 | else printf "${CWARNING}SKIP${CNORMAL}\n" >&2; fi | |
92 | } | |
93 | msgfail() { | |
94 | msgreportheader 'msgfail' | |
95 | if [ $# -gt 0 ] && [ -n "$1" ]; then printf "${CFAIL}FAIL: $*${CNORMAL}\n" >&2; | |
96 | else printf "${CFAIL}FAIL${CNORMAL}\n" >&2; fi | |
97 | if [ -n "$APT_DEBUG_TESTS" ]; then | |
98 | $SHELL | |
99 | fi | |
100 | EXIT_CODE=$((EXIT_CODE+1)); | |
101 | } | |
102 | MSGGROUP_LEVEL=0 | |
103 | msggroup() { | |
104 | if [ -n "$1" ]; then | |
105 | if [ $MSGGROUP_LEVEL = 0 ]; then | |
106 | MSGTEST_GRP='NEXT' | |
107 | fi | |
108 | MSGGROUP_LEVEL=$((MSGGROUP_LEVEL+1)); | |
109 | else | |
110 | MSGGROUP_LEVEL=$((MSGGROUP_LEVEL-1)); | |
111 | if [ $MSGGROUP_LEVEL = 0 ]; then | |
112 | unset MSGTEST_GRP | |
113 | fi | |
114 | fi | |
115 | } | |
116 | ||
117 | # enable / disable Debugging | |
118 | if [ $MSGLEVEL -le 0 ]; then | |
119 | msgdie() { true; } | |
120 | fi | |
121 | if [ $MSGLEVEL -le 1 ]; then | |
122 | msgwarn() { true; } | |
123 | msgnwarn() { true; } | |
124 | fi | |
125 | if [ $MSGLEVEL -le 2 ]; then | |
126 | msgmsg() { | |
127 | MSGTEST_MSGMSG="$(msgprintf "${CMSG}%s" '%s' "${CNORMAL}" "$@")" | |
128 | } | |
129 | msgnmsg() { true; } | |
130 | msgtest() { | |
131 | MSGTEST_MSG="$(msgprintf "${CINFO}%s" "${CCMD}%s${CINFO}" "…${CNORMAL} " "$@")" | |
132 | if [ "$MSGTEST_GRP" = 'NEXT' ]; then | |
133 | MSGTEST_GRP="$MSGTEST_MSG" | |
134 | fi | |
135 | } | |
136 | msgpass() { printf " ${CPASS}P${CNORMAL}"; } | |
137 | fi | |
138 | if [ $MSGLEVEL -le 3 ]; then | |
139 | msginfo() { true; } | |
140 | msgninfo() { true; } | |
141 | fi | |
142 | if [ $MSGLEVEL -le 4 ]; then | |
143 | msgdebug() { true; } | |
144 | msgndebug() { true; } | |
145 | fi | |
146 | msgdone() { | |
147 | if [ "$1" = "debug" -a $MSGLEVEL -le 4 ] || | |
148 | [ "$1" = "info" -a $MSGLEVEL -le 3 ] || | |
149 | [ "$1" = "msg" -a $MSGLEVEL -le 2 ] || | |
150 | [ "$1" = "warn" -a $MSGLEVEL -le 1 ] || | |
151 | [ "$1" = "die" -a $MSGLEVEL -le 0 ]; then | |
152 | true; | |
153 | else | |
154 | printf "${CDONE}DONE${CNORMAL}\n"; | |
155 | fi | |
156 | } | |
157 | getaptconfig() { | |
158 | if [ -f ./aptconfig.conf ]; then | |
159 | echo "$(readlink -f ./aptconfig.conf)" | |
160 | elif [ -f ../aptconfig.conf ]; then | |
161 | echo "$(readlink -f ../aptconfig.conf)" | |
162 | elif [ -f ../../aptconfig.conf ]; then | |
163 | echo "$(readlink -f ../../aptconfig.conf)" | |
164 | elif [ -f "${TMPWORKINGDIRECTORY}/aptconfig.conf" ]; then | |
165 | echo "$(readlink -f "${TMPWORKINGDIRECTORY}/aptconfig.conf")" | |
166 | fi | |
167 | } | |
168 | runapt() { | |
169 | msgdebug "Executing: ${CCMD}$*${CDEBUG} " | |
170 | local CMD="$1" | |
171 | shift | |
172 | case $CMD in | |
173 | sh|aptitude|*/*|command) ;; | |
174 | *) CMD="${BUILDDIRECTORY}/$CMD";; | |
175 | esac | |
176 | MALLOC_PERTURB_=21 MALLOC_CHECK_=2 APT_CONFIG="$(getaptconfig)" LD_LIBRARY_PATH=${LIBRARYPATH} $CMD "$@" | |
177 | } | |
178 | aptconfig() { runapt apt-config "$@"; } | |
179 | aptcache() { runapt apt-cache "$@"; } | |
180 | aptcdrom() { runapt apt-cdrom "$@"; } | |
181 | aptget() { runapt apt-get "$@"; } | |
182 | aptftparchive() { runapt apt-ftparchive "$@"; } | |
183 | aptkey() { runapt apt-key "$@"; } | |
184 | aptmark() { runapt apt-mark "$@"; } | |
185 | aptsortpkgs() { runapt apt-sortpkgs "$@"; } | |
186 | apt() { runapt apt "$@"; } | |
187 | apthelper() { runapt "${APTHELPERBINDIR}/apt-helper" "$@"; } | |
188 | aptwebserver() { runapt "${APTWEBSERVERBINDIR}/aptwebserver" "$@"; } | |
189 | aptitude() { runapt aptitude "$@"; } | |
190 | aptextracttemplates() { runapt apt-extracttemplates "$@"; } | |
191 | aptinternalsolver() { runapt "${APTINTERNALSOLVER}" "$@"; } | |
192 | aptdumpsolver() { runapt "${APTDUMPSOLVER}" "$@"; } | |
193 | ||
194 | dpkg() { | |
195 | "${TMPWORKINGDIRECTORY}/rootdir/usr/bin/dpkg" "$@" | |
196 | } | |
197 | dpkgcheckbuilddeps() { | |
198 | command dpkg-checkbuilddeps --admindir="${TMPWORKINGDIRECTORY}/rootdir/var/lib/dpkg" "$@" | |
199 | } | |
200 | gdb() { | |
201 | local CMD | |
202 | case "$1" in | |
203 | aptget) CMD="apt-get";; | |
204 | aptcache) CMD="apt-cache";; | |
205 | aptcdrom) CMD="apt-cdrom";; | |
206 | aptconfig) CMD="apt-config";; | |
207 | aptmark) CMD="apt-mark";; | |
208 | apthelper) CMD="apt-helper";; | |
209 | aptftparchive) CMD="apt-ftparchive";; | |
210 | dpkg) shift; runapt "${TMPWORKINGDIRECTORY}/rootdir/usr/bin/gdb-dpkg" "$@"; return;; | |
211 | *) CMD="$1";; | |
212 | esac | |
213 | shift | |
214 | if [ "${CMD##*/}" = "$CMD" ]; then | |
215 | CMD="${BUILDDIRECTORY}/${CMD}" | |
216 | fi | |
217 | runapt command gdb --quiet -ex run "$CMD" --args "$CMD" "$@" | |
218 | } | |
219 | ||
220 | exitwithstatus() { | |
221 | # error if we about to overflow, but ... | |
222 | # "255 failures ought to be enough for everybody" | |
223 | if [ $EXIT_CODE -gt 255 ]; then | |
224 | msgdie "Total failure count $EXIT_CODE too big" | |
225 | fi | |
226 | exit $((EXIT_CODE <= 255 ? EXIT_CODE : 255)); | |
227 | } | |
228 | ||
229 | shellsetedetector() { | |
230 | local exit_status=$? | |
231 | if [ "$exit_status" != '0' ]; then | |
232 | printf >&2 "${CERROR}E: Looks like the testcases ended prematurely with exitcode: ${exit_status}${CNORMAL}\n" | |
233 | if [ "$EXIT_CODE" = '0' ]; then | |
234 | EXIT_CODE="$exit_status" | |
235 | fi | |
236 | fi | |
237 | } | |
238 | ||
239 | addtrap() { | |
240 | if [ "$1" = 'prefix' ]; then | |
241 | CURRENTTRAP="$2 $CURRENTTRAP" | |
242 | else | |
243 | CURRENTTRAP="$CURRENTTRAP $1" | |
244 | fi | |
245 | trap "shellsetedetector; $CURRENTTRAP exitwithstatus;" 0 HUP INT QUIT ILL ABRT FPE SEGV PIPE TERM | |
246 | } | |
247 | ||
248 | setupenvironment() { | |
249 | # privilege dropping and testing doesn't work if /tmp isn't world-writeable (as e.g. with libpam-tmpdir) | |
250 | if [ -n "$TMPDIR" ] && [ "$(id -u)" = '0' ] && [ "$(stat --format '%a' "$TMPDIR")" != '1777' ]; then | |
251 | unset TMPDIR | |
252 | fi | |
253 | TMPWORKINGDIRECTORY="$(mktemp -d)" | |
254 | addtrap "cd /; rm -rf \"$TMPWORKINGDIRECTORY\";" | |
255 | msgninfo "Preparing environment for ${0##*/} in ${TMPWORKINGDIRECTORY}…" | |
256 | ||
257 | mkdir -m 700 "${TMPWORKINGDIRECTORY}/downloaded" | |
258 | if [ "$(id -u)" = '0' ]; then | |
259 | # relax permissions so that running as root with user switching works | |
260 | umask 022 | |
261 | chmod 711 "$TMPWORKINGDIRECTORY" | |
262 | chown _apt:root "${TMPWORKINGDIRECTORY}/downloaded" | |
263 | fi | |
264 | ||
265 | TESTDIRECTORY="$(readlink -f "$(dirname $0)")" | |
266 | # allow overriding the default BUILDDIR location | |
267 | SOURCEDIRECTORY="${APT_INTEGRATION_TESTS_SOURCE_DIR:-"${TESTDIRECTORY}/../../"}" | |
268 | BUILDDIRECTORY="${APT_INTEGRATION_TESTS_BUILD_DIR:-"${TESTDIRECTORY}/../../build/bin"}" | |
269 | LIBRARYPATH="${APT_INTEGRATION_TESTS_LIBRARY_PATH:-"${BUILDDIRECTORY}"}" | |
270 | METHODSDIR="${APT_INTEGRATION_TESTS_METHODS_DIR:-"${BUILDDIRECTORY}/methods"}" | |
271 | APTHELPERBINDIR="${APT_INTEGRATION_TESTS_LIBEXEC_DIR:-"${BUILDDIRECTORY}"}" | |
272 | APTWEBSERVERBINDIR="${APT_INTEGRATION_TESTS_WEBSERVER_BIN_DIR:-"${BUILDDIRECTORY}"}" | |
273 | APTINTERNALSOLVER="${APT_INTEGRATION_TESTS_INTERNAL_SOLVER:-"${BUILDDIRECTORY}/apt-internal-solver"}" | |
274 | APTDUMPSOLVER="${APT_INTEGRATION_TESTS_DUMP_SOLVER:-"${BUILDDIRECTORY}/apt-dump-solver"}" | |
275 | test -x "${BUILDDIRECTORY}/apt-get" || msgdie "You need to build tree first" | |
276 | # ----- | |
277 | ||
278 | cd "$TMPWORKINGDIRECTORY" | |
279 | mkdir rootdir aptarchive keys | |
280 | cd rootdir | |
281 | mkdir -p etc/apt/apt.conf.d etc/apt/sources.list.d etc/apt/trusted.gpg.d etc/apt/preferences.d | |
282 | mkdir -p usr/bin var/cache var/lib var/log tmp | |
283 | mkdir -p var/lib/dpkg/info var/lib/dpkg/updates var/lib/dpkg/triggers | |
284 | touch var/lib/dpkg/available | |
285 | mkdir -p usr/lib/apt | |
286 | ln -s "${METHODSDIR}" usr/lib/apt/methods | |
287 | if [ "$BUILDDIRECTORY" = "$LIBRARYPATH" ]; then | |
288 | mkdir -p usr/lib/apt/solvers | |
289 | ln -s "${BUILDDIRECTORY}/apt-dump-solver" usr/lib/apt/solvers/dump | |
290 | ln -s "${BUILDDIRECTORY}/apt-internal-solver" usr/lib/apt/solvers/apt | |
291 | echo "Dir::Bin::Solvers \"${TMPWORKINGDIRECTORY}/rootdir/usr/lib/apt/solvers\";" > etc/apt/apt.conf.d/externalsolver.conf | |
292 | fi | |
293 | # use the autoremove from the BUILDDIRECTORY if its there, otherwise | |
294 | # system | |
295 | if [ -e "${BUILDDIRECTORY}/../../debian/apt.conf.autoremove" ]; then | |
296 | ln -s "${BUILDDIRECTORY}/../../debian/apt.conf.autoremove" etc/apt/apt.conf.d/01autoremove | |
297 | else | |
298 | ln -s /etc/apt/apt.conf.d/01autoremove etc/apt/apt.conf.d/01autoremove | |
299 | fi | |
300 | cd .. | |
301 | local BASENAME="${0##*/}" | |
302 | local PACKAGESFILE="Packages-${BASENAME#*-}" | |
303 | if [ -f "${TESTDIRECTORY}/${PACKAGESFILE}" ]; then | |
304 | cp "${TESTDIRECTORY}/${PACKAGESFILE}" aptarchive/Packages | |
305 | fi | |
306 | local SOURCESSFILE="Sources-${BASENAME#*-}" | |
307 | if [ -f "${TESTDIRECTORY}/${SOURCESSFILE}" ]; then | |
308 | cp "${TESTDIRECTORY}/${SOURCESSFILE}" aptarchive/Sources | |
309 | fi | |
310 | for key in $(find "$TESTDIRECTORY" -name '*.pub' -o -name '*.sec'); do | |
311 | cp "$key" keys/ | |
312 | chmod 644 "$key" | |
313 | done | |
314 | ln -s "${TMPWORKINGDIRECTORY}/keys/joesixpack.pub" rootdir/etc/apt/trusted.gpg.d/joesixpack.gpg | |
315 | ||
316 | echo "Dir \"${TMPWORKINGDIRECTORY}/rootdir\";" > aptconfig.conf | |
317 | echo "Dir::state::status \"${TMPWORKINGDIRECTORY}/rootdir/var/lib/dpkg/status\";" >> aptconfig.conf | |
318 | echo "APT::Get::Show-User-Simulation-Note \"false\";" >> aptconfig.conf | |
319 | echo "Dir::Bin::Methods \"${TMPWORKINGDIRECTORY}/rootdir/usr/lib/apt/methods\";" >> aptconfig.conf | |
320 | # either store apt-key were we can access it, even if we run it as a different user | |
321 | #cp "${BUILDDIRECTORY}/apt-key" "${TMPWORKINGDIRECTORY}/rootdir/usr/bin/" | |
322 | #chmod o+rx "${TMPWORKINGDIRECTORY}/rootdir/usr/bin/apt-key" | |
323 | #echo "Dir::Bin::apt-key \"${TMPWORKINGDIRECTORY}/rootdir/usr/bin/apt-key\";" >> aptconfig.conf | |
324 | # destroys coverage reporting though, so we disable changing user for the calling gpgv | |
325 | echo "Dir::Bin::apt-key \"${BUILDDIRECTORY}/apt-key\";" >> aptconfig.conf | |
326 | if [ "$(id -u)" = '0' ]; then | |
327 | echo 'Binary::gpgv::Debug::NoDropPrivs "true";' >>aptconfig.conf | |
328 | fi | |
329 | ||
330 | cat > "${TMPWORKINGDIRECTORY}/rootdir/usr/bin/dpkg" <<EOF | |
331 | #!/bin/sh | |
332 | set -e | |
333 | if [ -r "${TMPWORKINGDIRECTORY}/noopchroot.so" ]; then | |
334 | if [ -n "\$LD_LIBRARY_PATH" ]; then | |
335 | export LD_LIBRARY_PATH="${TMPWORKINGDIRECTORY}:${LD_LIBRARY_PATH}" | |
336 | else | |
337 | export LD_LIBRARY_PATH="${TMPWORKINGDIRECTORY}" | |
338 | fi | |
339 | if [ -n "\$LD_PRELOAD" ]; then | |
340 | export LD_PRELOAD="noopchroot.so \${LD_PRELOAD}" | |
341 | else | |
342 | export LD_PRELOAD="noopchroot.so" | |
343 | fi | |
344 | fi | |
345 | EOF | |
346 | cp "${TMPWORKINGDIRECTORY}/rootdir/usr/bin/dpkg" "${TMPWORKINGDIRECTORY}/rootdir/usr/bin/gdb-dpkg" | |
347 | cat >> "${TMPWORKINGDIRECTORY}/rootdir/usr/bin/dpkg" <<EOF | |
348 | exec fakeroot "${DPKG:-dpkg}" --root="${TMPWORKINGDIRECTORY}/rootdir" \\ | |
349 | --log="${TMPWORKINGDIRECTORY}/rootdir/var/log/dpkg.log" \\ | |
350 | --force-not-root --force-bad-path "\$@" | |
351 | EOF | |
352 | cat >> "${TMPWORKINGDIRECTORY}/rootdir/usr/bin/gdb-dpkg" <<EOF | |
353 | exec fakeroot gdb --quiet -ex run "${DPKG:-dpkg}" --args "${DPKG:-dpkg}" --root="${TMPWORKINGDIRECTORY}/rootdir" \\ | |
354 | --log="${TMPWORKINGDIRECTORY}/rootdir/var/log/dpkg.log" \\ | |
355 | --force-not-root --force-bad-path "\$@" | |
356 | EOF | |
357 | chmod +x "${TMPWORKINGDIRECTORY}/rootdir/usr/bin/dpkg" "${TMPWORKINGDIRECTORY}/rootdir/usr/bin/gdb-dpkg" | |
358 | echo "Dir::Bin::dpkg \"${TMPWORKINGDIRECTORY}/rootdir/usr/bin/dpkg\";" > rootdir/etc/apt/apt.conf.d/99dpkg | |
359 | ||
360 | { | |
361 | if ! command dpkg --assert-multi-arch >/dev/null 2>&1; then | |
362 | echo "DPKG::options:: \"--force-architecture\";" # Added to test multiarch before dpkg is ready for it… | |
363 | fi | |
364 | echo 'quiet::NoUpdate "true";' | |
365 | echo 'quiet::NoStatistic "true";' | |
366 | # too distracting for users, but helpful to detect changes | |
367 | echo 'Acquire::Progress::Ignore::ShowErrorText "true";' | |
368 | echo 'Acquire::Progress::Diffpercent "true";' | |
369 | # in testcases, it can appear as if localhost has a rotation setup, | |
370 | # hide this as we can't really deal with it properly | |
371 | echo 'Acquire::Failure::ShowIP "false";' | |
372 | } >> aptconfig.conf | |
373 | ||
374 | cp "${TESTDIRECTORY}/apt.pem" "${TMPWORKINGDIRECTORY}/rootdir/etc/webserver.pem" | |
375 | if [ "$(id -u)" = '0' ]; then | |
376 | chown _apt:root "${TMPWORKINGDIRECTORY}/rootdir/etc/webserver.pem" | |
377 | fi | |
378 | echo "Acquire::https::CaInfo \"${TMPWORKINGDIRECTORY}/rootdir/etc/webserver.pem\";" > rootdir/etc/apt/apt.conf.d/99https | |
379 | echo "Apt::Cmd::Disable-Script-Warning \"1\";" > rootdir/etc/apt/apt.conf.d/apt-binary | |
380 | echo 'Acquire::Connect::AddrConfig "false";' > rootdir/etc/apt/apt.conf.d/connect-addrconfig | |
381 | configcompression '.' 'gz' #'bz2' 'lzma' 'xz' | |
382 | confighashes 'SHA1' # these are tests, not security best-practices | |
383 | ||
384 | # create some files in /tmp and look at user/group to get what this means | |
385 | TEST_DEFAULT_USER="$USER" | |
386 | if [ "$(uname)" = 'GNU/kFreeBSD' ]; then | |
387 | TEST_DEFAULT_GROUP='root' | |
388 | else | |
389 | TEST_DEFAULT_GROUP="$USER" | |
390 | fi | |
391 | ||
392 | # cleanup the environment a bit | |
393 | # prefer our apt binaries over the system apt binaries | |
394 | export PATH="${BUILDDIRECTORY}:${PATH}:/usr/local/sbin:/usr/sbin:/sbin" | |
395 | export LC_ALL=C.UTF-8 | |
396 | unset LANGUAGE APT_CONFIG | |
397 | unset GREP_OPTIONS DEB_BUILD_PROFILES | |
398 | msgdone "info" | |
399 | } | |
400 | ||
401 | getarchitecture() { | |
402 | if [ "$1" = "native" -o -z "$1" ]; then | |
403 | eval `aptconfig shell ARCH APT::Architecture` | |
404 | if [ -n "$ARCH" ]; then | |
405 | echo $ARCH | |
406 | else | |
407 | dpkg --print-architecture | |
408 | fi | |
409 | else | |
410 | echo $1 | |
411 | fi | |
412 | } | |
413 | ||
414 | getarchitectures() { | |
415 | aptconfig dump --no-empty --format '%v%n' APT::Architecture APT::Architectures | sort -u | tr '\n' ' ' | |
416 | } | |
417 | ||
418 | getarchitecturesfromcommalist() { | |
419 | echo "$1" | sed -e 's#,#\n#g' | sed -e "s/^native\$/$(getarchitecture 'native')/" | |
420 | } | |
421 | ||
422 | configarchitecture() { | |
423 | { | |
424 | echo "APT::Architecture \"$(getarchitecture $1)\";" | |
425 | while [ -n "$1" ]; do | |
426 | echo "APT::Architectures:: \"$(getarchitecture $1)\";" | |
427 | shift | |
428 | done | |
429 | } >rootdir/etc/apt/apt.conf.d/01multiarch.conf | |
430 | configdpkg | |
431 | } | |
432 | ||
433 | configdpkg() { | |
434 | if [ ! -e rootdir/var/lib/dpkg/status ]; then | |
435 | local BASENAME="${0##*/}" | |
436 | local STATUSFILE="status-${BASENAME#*-}" | |
437 | if [ -f "${TESTDIRECTORY}/${STATUSFILE}" ]; then | |
438 | cp "${TESTDIRECTORY}/${STATUSFILE}" rootdir/var/lib/dpkg/status | |
439 | else | |
440 | echo -n > rootdir/var/lib/dpkg/status | |
441 | fi | |
442 | fi | |
443 | rm -f rootdir/etc/apt/apt.conf.d/00foreigndpkg | |
444 | if command dpkg --assert-multi-arch >/dev/null 2>&1 ; then | |
445 | local ARCHS="$(getarchitectures)" | |
446 | if echo "$ARCHS" | grep -E -q '[^ ]+ [^ ]+'; then | |
447 | DPKGARCH="$(dpkg --print-architecture)" | |
448 | for ARCH in ${ARCHS}; do | |
449 | if [ "${ARCH}" != "${DPKGARCH}" ]; then | |
450 | if ! dpkg --add-architecture ${ARCH} >/dev/null 2>&1; then | |
451 | # old-style used e.g. in Ubuntu-P – and as it seems travis | |
452 | echo "DPKG::options:: \"--foreign-architecture\";" >> rootdir/etc/apt/apt.conf.d/00foreigndpkg | |
453 | echo "DPKG::options:: \"${ARCH}\";" >> rootdir/etc/apt/apt.conf.d/00foreigndpkg | |
454 | fi | |
455 | fi | |
456 | done | |
457 | if [ "0" = "$(dpkg -l dpkg 2> /dev/null | grep '^i' | wc -l)" ]; then | |
458 | # dpkg doesn't really check the version as long as it is fully installed, | |
459 | # but just to be sure we choose one above the required version | |
460 | insertinstalledpackage 'dpkg' "all" '1.16.2+fake' | |
461 | fi | |
462 | fi | |
463 | fi | |
464 | } | |
465 | ||
466 | configdpkgnoopchroot() { | |
467 | # create a library to noop chroot() and rewrite maintainer script executions | |
468 | # via execvp() as used by dpkg as we don't want our rootdir to be a fullblown | |
469 | # chroot directory dpkg could chroot into to execute the maintainer scripts | |
470 | msgtest 'Building library to preload to make maintainerscript work in' 'dpkg' | |
471 | cat > noopchroot.c << EOF | |
472 | #define _GNU_SOURCE | |
473 | #include <stdio.h> | |
474 | #include <stdlib.h> | |
475 | #include <string.h> | |
476 | #include <dlfcn.h> | |
477 | ||
478 | static char * chrootdir = NULL; | |
479 | ||
480 | int chroot(const char *path) { | |
481 | printf("WARNING: CHROOTing to %s was ignored!\n", path); | |
482 | free(chrootdir); | |
483 | chrootdir = strdup(path); | |
484 | return 0; | |
485 | } | |
486 | int execvp(const char *file, char *const argv[]) { | |
487 | static int (*func_execvp) (const char *, char * const []) = NULL; | |
488 | if (func_execvp == NULL) | |
489 | func_execvp = (int (*) (const char *, char * const [])) dlsym(RTLD_NEXT, "execvp"); | |
490 | if (chrootdir == NULL || strncmp(file, "/var/lib/dpkg/", strlen("/var/lib/dpkg/")) != 0) | |
491 | return func_execvp(file, argv); | |
492 | printf("REWRITE execvp call %s into %s\n", file, chrootdir); | |
493 | char newfile[strlen(chrootdir) + strlen(file)]; | |
494 | strcpy(newfile, chrootdir); | |
495 | strcat(newfile, file); | |
496 | char const * const baseadmindir = "/var/lib/dpkg"; | |
497 | char admindir[strlen(chrootdir) + strlen(baseadmindir)]; | |
498 | strcpy(admindir, chrootdir); | |
499 | strcat(admindir, baseadmindir); | |
500 | setenv("DPKG_ADMINDIR", admindir, 1); | |
501 | return func_execvp(newfile, argv); | |
502 | } | |
503 | EOF | |
504 | testsuccess --nomsg gcc -fPIC -shared -o noopchroot.so noopchroot.c -ldl | |
505 | } | |
506 | configcompression() { | |
507 | while [ -n "$1" ]; do | |
508 | case "$1" in | |
509 | '.') printf ".\t.\tcat\n";; | |
510 | 'gz') printf "gzip\tgz\tgzip\n";; | |
511 | 'bz2') printf "bzip2\tbz2\tbzip2\n";; | |
512 | 'lzma') printf "lzma\tlzma\txz --format=lzma\n";; | |
513 | 'xz') printf "xz\txz\txz\n";; | |
514 | *) printf "$1\t$1\t$1\n";; | |
515 | esac | |
516 | shift | |
517 | done > "${TMPWORKINGDIRECTORY}/rootdir/etc/testcase-compressor.conf" | |
518 | } | |
519 | confighashes() { | |
520 | { | |
521 | echo 'APT::FTPArchive {' | |
522 | { | |
523 | while [ -n "$1" ]; do | |
524 | printf "$1" | tr 'a-z' 'A-Z' | |
525 | printf "\t\"true\";\n" | |
526 | shift | |
527 | done | |
528 | for h in 'MD5' 'SHA1' 'SHA256' 'SHA512'; do | |
529 | printf "$h\t\"false\";\n" | |
530 | done | |
531 | } | awk '!x[$1]++' | |
532 | echo '};' | |
533 | } >> "${TMPWORKINGDIRECTORY}/rootdir/etc/apt/apt.conf.d/ftparchive-hashes.conf" | |
534 | } | |
535 | forcecompressor() { | |
536 | COMPRESSOR="$1" | |
537 | COMPRESSOR_CMD="$1" | |
538 | case $COMPRESSOR in | |
539 | gzip) COMPRESS='gz';; | |
540 | bzip2) COMPRESS='bz2';; | |
541 | lzma) COMPRESS='lzma';; | |
542 | xz) COMPRESS='xz';; | |
543 | *) msgdie "Compressor $COMPRESSOR is unknown to framework, so can't be forced by forcecompressor!";; | |
544 | esac | |
545 | local CONFFILE="${TMPWORKINGDIRECTORY}/rootdir/etc/apt/apt.conf.d/00force-compressor" | |
546 | echo "Acquire::CompressionTypes::Order { \"${COMPRESS}\"; }; | |
547 | Dir::Bin::uncompressed \"/does/not/exist\"; | |
548 | Dir::Bin::gzip \"/does/not/exist\"; | |
549 | Dir::Bin::bzip2 \"/does/not/exist\"; | |
550 | Dir::Bin::lzma \"/does/not/exist\"; | |
551 | Dir::Bin::xz \"/does/not/exist\";" > "$CONFFILE" | |
552 | if [ -e "/bin/${COMPRESSOR}" ]; then | |
553 | echo "Dir::Bin::${COMPRESSOR} \"/bin/${COMPRESSOR}\";" >> "$CONFFILE" | |
554 | elif [ -e "/usr/bin/${COMPRESSOR}" ]; then | |
555 | echo "Dir::Bin::${COMPRESSOR} \"/usr/bin/${COMPRESSOR}\";" >> "$CONFFILE" | |
556 | elif [ "${COMPRESSOR}" = 'lzma' ]; then | |
557 | echo 'Dir::Bin::xz "/usr/bin/xz";' >> "$CONFFILE" | |
558 | COMPRESSOR_CMD='xz --format=lzma' | |
559 | else | |
560 | msgtest 'Test for availability of compressor' "${COMPRESSOR}" | |
561 | msgfail "${COMPRESSOR} not available" | |
562 | fi | |
563 | } | |
564 | ||
565 | setupsimplenativepackage() { | |
566 | local NAME="$1" | |
567 | local ARCH="$2" | |
568 | local VERSION="$3" | |
569 | local RELEASE="${4:-unstable}" | |
570 | local DEPENDENCIES="$5" | |
571 | local DESCRIPTION="${6:-"an autogenerated dummy ${NAME}=${VERSION}/${RELEASE} | |
572 | If you find such a package installed on your system, | |
573 | something went horribly wrong! They are autogenerated | |
574 | und used only by testcases and surf no other propose…"}" | |
575 | ||
576 | local SECTION="${7:-others}" | |
577 | local DISTSECTION | |
578 | if [ "$SECTION" = "${SECTION#*/}" ]; then | |
579 | DISTSECTION="main" | |
580 | else | |
581 | DISTSECTION="${SECTION%/*}" | |
582 | fi | |
583 | local BUILDDIR=incoming/${NAME}-${VERSION} | |
584 | mkdir -p ${BUILDDIR}/debian/source | |
585 | cd ${BUILDDIR} | |
586 | echo "* most suckless software product ever" > FEATURES | |
587 | test -e debian/copyright || echo "Copyleft by Joe Sixpack $(date +%Y)" > debian/copyright | |
588 | test -e debian/changelog || echo "$NAME ($VERSION) $RELEASE; urgency=low | |
589 | ||
590 | * Initial release | |
591 | ||
592 | -- Joe Sixpack <joe@example.org> $(date -R)" > debian/changelog | |
593 | test -e debian/control || echo "Source: $NAME | |
594 | Section: $SECTION | |
595 | Priority: optional | |
596 | Maintainer: Joe Sixpack <joe@example.org> | |
597 | Build-Depends: debhelper (>= 7) | |
598 | Standards-Version: 3.9.1 | |
599 | ||
600 | Package: $NAME" > debian/control | |
601 | if [ "$ARCH" = 'all' ]; then | |
602 | echo "Architecture: all" >> debian/control | |
603 | else | |
604 | echo "Architecture: any" >> debian/control | |
605 | fi | |
606 | test -z "$DEPENDENCIES" || echo "$DEPENDENCIES" >> debian/control | |
607 | echo "Description: $DESCRIPTION" >> debian/control | |
608 | ||
609 | test -e debian/compat || echo "7" > debian/compat | |
610 | test -e debian/source/format || echo "3.0 (native)" > debian/source/format | |
611 | test -e debian/rules || cp /usr/share/doc/debhelper/examples/rules.tiny debian/rules | |
612 | cd - > /dev/null | |
613 | } | |
614 | ||
615 | buildsimplenativepackage() { | |
616 | local NAME="$1" | |
617 | local NM | |
618 | if [ "$(echo "$NAME" | cut -c 1-3)" = 'lib' ]; then | |
619 | NM="$(echo "$NAME" | cut -c 1-4)" | |
620 | else | |
621 | NM="$(echo "$NAME" | cut -c 1)" | |
622 | fi | |
623 | local ARCH="$2" | |
624 | local VERSION="$3" | |
625 | local RELEASE="${4:-unstable}" | |
626 | local DEPENDENCIES="$5" | |
627 | local DESCRIPTION="${6:-"an autogenerated dummy ${NAME}=${VERSION}/${RELEASE} | |
628 | If you find such a package installed on your system, | |
629 | something went horribly wrong! They are autogenerated | |
630 | und used only by testcases and surf no other propose…"}" | |
631 | ||
632 | local SECTION="${7:-others}" | |
633 | local PRIORITY="${8:-optional}" | |
634 | local FILE_TREE="$9" | |
635 | local COMPRESS_TYPE="${10:-gzip}" | |
636 | local DISTSECTION | |
637 | if [ "$SECTION" = "${SECTION#*/}" ]; then | |
638 | DISTSECTION="main" | |
639 | else | |
640 | DISTSECTION="${SECTION%/*}" | |
641 | fi | |
642 | local BUILDDIR="${TMPWORKINGDIRECTORY}/incoming/${NAME}-${VERSION}" | |
643 | ||
644 | msgtest "Build source package in version ${VERSION} for ${RELEASE} in ${DISTSECTION}" "$NAME" | |
645 | mkdir -p "$BUILDDIR/debian/source" | |
646 | echo "* most suckless software product ever" > "${BUILDDIR}/FEATURES" | |
647 | echo "#!/bin/sh | |
648 | echo '$NAME says \"Hello!\"'" > "${BUILDDIR}/${NAME}" | |
649 | ||
650 | echo "Copyleft by Joe Sixpack $(date +%Y)" > "${BUILDDIR}/debian/copyright" | |
651 | echo "$NAME ($VERSION) $RELEASE; urgency=low | |
652 | ||
653 | * Initial release | |
654 | ||
655 | -- Joe Sixpack <joe@example.org> $(date -R)" > "${BUILDDIR}/debian/changelog" | |
656 | { | |
657 | echo "Source: $NAME | |
658 | Priority: $PRIORITY | |
659 | Maintainer: Joe Sixpack <joe@example.org> | |
660 | Standards-Version: 3.9.3" | |
661 | if [ "$SECTION" != '<none>' ]; then | |
662 | echo "Section: $SECTION" | |
663 | fi | |
664 | local BUILDDEPS="$(echo "$DEPENDENCIES" | grep '^Build-')" | |
665 | test -z "$BUILDDEPS" || echo "$BUILDDEPS" | |
666 | echo " | |
667 | Package: $NAME" | |
668 | ||
669 | if [ "$ARCH" = 'all' ]; then | |
670 | echo "Architecture: all" | |
671 | else | |
672 | echo "Architecture: any" | |
673 | fi | |
674 | local DEPS="$(echo "$DEPENDENCIES" | grep -v '^Build-')" | |
675 | test -z "$DEPS" || echo "$DEPS" | |
676 | echo "Description: $DESCRIPTION" | |
677 | } > "${BUILDDIR}/debian/control" | |
678 | ||
679 | echo '3.0 (native)' > "${BUILDDIR}/debian/source/format" | |
680 | cd "${BUILDDIR}/.." | |
681 | testsuccess --nomsg dpkg-source -b ${NAME}-${VERSION} | |
682 | cd - >/dev/null | |
683 | sed -n 's#^dpkg-source: info: building [^ ]\+ in ##p' "${TMPWORKINGDIRECTORY}/rootdir/tmp/testsuccess.output" \ | |
684 | | while read SRC; do | |
685 | echo "pool/${SRC}" >> "${BUILDDIR}/../${RELEASE}.${DISTSECTION}.srclist" | |
686 | # if expr match "${SRC}" '.*\.dsc' >/dev/null 2>&1; then | |
687 | # aptkey --keyring ./keys/joesixpack.pub --secret-keyring ./keys/joesixpack.sec --quiet --readonly \ | |
688 | # adv --yes --default-key 'Joe Sixpack' \ | |
689 | # --clearsign -o "${BUILDDIR}/../${SRC}.sign" "${BUILDDIR}/../$SRC" | |
690 | # mv "${BUILDDIR}/../${SRC}.sign" "${BUILDDIR}/../$SRC" | |
691 | # fi | |
692 | done | |
693 | ||
694 | for arch in $(getarchitecturesfromcommalist "$ARCH"); do | |
695 | msgtest "Build binary package for ${RELEASE} in ${SECTION}" "$NAME" | |
696 | rm -rf "${BUILDDIR}/debian/tmp" | |
697 | mkdir -p "${BUILDDIR}/debian/tmp/DEBIAN" "${BUILDDIR}/debian/tmp/usr/share/doc/${NAME}" "${BUILDDIR}/debian/tmp/usr/bin" | |
698 | cp "${BUILDDIR}/debian/copyright" "${BUILDDIR}/debian/changelog" "${BUILDDIR}/FEATURES" "${BUILDDIR}/debian/tmp/usr/share/doc/${NAME}" | |
699 | cp "${BUILDDIR}/${NAME}" "${BUILDDIR}/debian/tmp/usr/bin/${NAME}-${arch}" | |
700 | if [ -n "$FILE_TREE" ]; then | |
701 | cp -ar "$FILE_TREE" "${BUILDDIR}/debian/tmp" | |
702 | fi | |
703 | ||
704 | (cd "${BUILDDIR}"; dpkg-gencontrol -DArchitecture=$arch) | |
705 | (cd "${BUILDDIR}/debian/tmp"; md5sum $(find usr/ -type f) > DEBIAN/md5sums) | |
706 | local LOG="${BUILDDIR}/../${NAME}_${VERSION}_${arch}.dpkg-deb.log" | |
707 | # ensure the right permissions as dpkg-deb insists | |
708 | chmod 755 "${BUILDDIR}/debian/tmp/DEBIAN" | |
709 | testsuccess --nomsg dpkg-deb -Z${COMPRESS_TYPE} --build "${BUILDDIR}/debian/tmp" "${BUILDDIR}/.." | |
710 | echo "pool/${NAME}_${VERSION}_${arch}.deb" >> "${BUILDDIR}/../${RELEASE}.${DISTSECTION}.pkglist" | |
711 | done | |
712 | ||
713 | local CHANGEPATH="${BUILDDIR}/../${DISTSECTION}/${NM}/${NAME}/${NAME}_${VERSION}" | |
714 | mkdir -p "$CHANGEPATH" | |
715 | cp "${BUILDDIR}/debian/changelog" "$CHANGEPATH" | |
716 | rm -rf "${BUILDDIR}" | |
717 | msgdone "info" | |
718 | } | |
719 | ||
720 | buildpackage() { | |
721 | local BUILDDIR=$1 | |
722 | local RELEASE=$2 | |
723 | local SECTION=$3 | |
724 | local ARCH=$(getarchitecture $4) | |
725 | local PKGNAME="$(echo "$BUILDDIR" | grep -o '[^/]*$')" | |
726 | local BUILDLOG="$(readlink -f "${BUILDDIR}/../${PKGNAME}_${RELEASE}_${SECTION}.dpkg-bp.log")" | |
727 | msgtest "Build package for ${RELEASE} in ${SECTION}" "$PKGNAME" | |
728 | cd "$BUILDDIR" | |
729 | if [ "$ARCH" = "all" ]; then | |
730 | ARCH="$(dpkg-architecture -qDEB_HOST_ARCH 2> /dev/null)" | |
731 | fi | |
732 | testsuccess --nomsg dpkg-buildpackage -uc -us -a$ARCH | |
733 | cp "${TMPWORKINGDIRECTORY}/rootdir/tmp/testsuccess.output" "$BUILDLOG" | |
734 | local PKGS="$(grep '^dpkg-deb: building package' "$BUILDLOG" | cut -d'/' -f 2 | sed -e "s#'\.##")" | |
735 | local SRCS="$(grep '^dpkg-source: info: building' "$BUILDLOG" | grep -o '[a-z0-9._+~-]*$')" | |
736 | cd - > /dev/null | |
737 | for PKG in $PKGS; do | |
738 | echo "pool/${PKG}" >> "${TMPWORKINGDIRECTORY}/incoming/${RELEASE}.${SECTION}.pkglist" | |
739 | done | |
740 | for SRC in $SRCS; do | |
741 | echo "pool/${SRC}" >> "${TMPWORKINGDIRECTORY}/incoming/${RELEASE}.${SECTION}.srclist" | |
742 | done | |
743 | } | |
744 | ||
745 | buildaptarchive() { | |
746 | if [ -d incoming ]; then | |
747 | buildaptarchivefromincoming "$@" | |
748 | else | |
749 | buildaptarchivefromfiles "$@" | |
750 | fi | |
751 | } | |
752 | ||
753 | createaptftparchiveconfig() { | |
754 | local COMPRESSORS="$(cut -d' ' -f 1 "${TMPWORKINGDIRECTORY}/rootdir/etc/testcase-compressor.conf" | tr '\n' ' ')" | |
755 | local COMPRESSORS="${COMPRESSORS%* }" | |
756 | local ARCHS="$(getarchitectures)" | |
757 | cat > ftparchive.conf <<EOF | |
758 | Dir { | |
759 | ArchiveDir "$(readlink -f .)"; | |
760 | CacheDir "$(readlink -f ..)"; | |
761 | FileListDir "$(readlink -f pool/)"; | |
762 | }; | |
763 | Default { | |
764 | Packages::Compress "$COMPRESSORS"; | |
765 | Sources::Compress "$COMPRESSORS"; | |
766 | Contents::Compress "$COMPRESSORS"; | |
767 | Translation::Compress "$COMPRESSORS"; | |
768 | LongDescription "false"; | |
769 | }; | |
770 | TreeDefault { | |
771 | Directory "pool/"; | |
772 | SrcDirectory "pool/"; | |
773 | }; | |
774 | EOF | |
775 | for DIST in $(find ./pool/ -maxdepth 1 -name '*.pkglist' -type f | cut -d'/' -f 3 | cut -d'.' -f 1 | sort | uniq); do | |
776 | cat <<EOF | |
777 | tree "dists/$DIST" { | |
778 | Architectures "$ARCHS all source"; | |
779 | FileList "${DIST}.\$(SECTION).pkglist"; | |
780 | SourceFileList "${DIST}.\$(SECTION).srclist"; | |
781 | Sections "$(find ./pool/ -maxdepth 1 -name "${DIST}.*.pkglist" -type f | cut -d'/' -f 3 | cut -d'.' -f 2 | sort | uniq | tr '\n' ' ')"; | |
782 | }; | |
783 | EOF | |
784 | done >> ftparchive.conf | |
785 | } | |
786 | ||
787 | buildaptftparchivedirectorystructure() { | |
788 | local DISTS="$(grep -i '^tree ' ftparchive.conf | cut -d'/' -f 2 | sed -e 's#".*##')" | |
789 | for DIST in $DISTS; do | |
790 | local SECTIONS="$(grep -i -A 5 "dists/$DIST" ftparchive.conf | grep -i 'Sections' | cut -d'"' -f 2)" | |
791 | for SECTION in $SECTIONS; do | |
792 | local ARCHS="$(grep -A 5 "dists/$DIST" ftparchive.conf | grep Architectures | cut -d'"' -f 2 | sed -e 's#source##')" | |
793 | for ARCH in $ARCHS; do | |
794 | mkdir -p "dists/${DIST}/${SECTION}/binary-${ARCH}" | |
795 | done | |
796 | mkdir -p "dists/${DIST}/${SECTION}/source" | |
797 | mkdir -p "dists/${DIST}/${SECTION}/i18n" | |
798 | done | |
799 | done | |
800 | } | |
801 | ||
802 | insertpackage() { | |
803 | local RELEASES="$1" | |
804 | local NAME="$2" | |
805 | local ARCH="$3" | |
806 | local VERSION="$4" | |
807 | local DEPENDENCIES="$5" | |
808 | local PRIORITY="${6:-optional}" | |
809 | local DESCRIPTION="${7:-"an autogenerated dummy ${NAME}=${VERSION}/${RELEASES} | |
810 | If you find such a package installed on your system, | |
811 | something went horribly wrong! They are autogenerated | |
812 | und used only by testcases and surf no other propose…"}" | |
813 | local ARCHS="" | |
814 | for RELEASE in $(printf '%s' "$RELEASES" | tr ',' '\n'); do | |
815 | if [ "$RELEASE" = 'installed' ]; then | |
816 | insertinstalledpackage "$2" "$3" "$4" "$5" "$6" "$7" | |
817 | continue | |
818 | fi | |
819 | for arch in $(getarchitecturesfromcommalist "$ARCH"); do | |
820 | if [ "$arch" = 'none' ]; then | |
821 | ARCHS="$(getarchitectures)" | |
822 | else | |
823 | ARCHS="$arch" | |
824 | fi | |
825 | for BUILDARCH in $ARCHS; do | |
826 | local PPATH="aptarchive/dists/${RELEASE}/main/binary-${BUILDARCH}" | |
827 | mkdir -p "$PPATH" | |
828 | { | |
829 | echo "Package: $NAME | |
830 | Priority: $PRIORITY | |
831 | Section: other | |
832 | Installed-Size: 42 | |
833 | Maintainer: Joe Sixpack <joe@example.org>" | |
834 | test "$arch" = 'none' || echo "Architecture: $arch" | |
835 | echo "Version: $VERSION | |
836 | Filename: pool/main/${NAME}/${NAME}_${VERSION}_${arch}.deb" | |
837 | test -z "$DEPENDENCIES" || echo "$DEPENDENCIES" | |
838 | echo "Description: $(printf '%s' "$DESCRIPTION" | head -n 1)" | |
839 | echo "Description-md5: $(printf '%s' "$DESCRIPTION" | md5sum | cut -d' ' -f 1)" | |
840 | echo | |
841 | } >> "${PPATH}/Packages" | |
842 | done | |
843 | done | |
844 | mkdir -p "aptarchive/dists/${RELEASE}/main/source" "aptarchive/dists/${RELEASE}/main/i18n" | |
845 | touch "aptarchive/dists/${RELEASE}/main/source/Sources" | |
846 | echo "Package: $NAME | |
847 | Description-md5: $(printf '%s' "$DESCRIPTION" | md5sum | cut -d' ' -f 1) | |
848 | Description-en: $DESCRIPTION | |
849 | " >> "aptarchive/dists/${RELEASE}/main/i18n/Translation-en" | |
850 | done | |
851 | } | |
852 | ||
853 | insertsource() { | |
854 | local RELEASE="$1" | |
855 | local NAME="$2" | |
856 | local ARCH="$3" | |
857 | local VERSION="$4" | |
858 | local DEPENDENCIES="$5" | |
859 | local BINARY="${6:-$NAME}" | |
860 | local ARCHS="" | |
861 | local SPATH="aptarchive/dists/${RELEASE}/main/source" | |
862 | mkdir -p $SPATH | |
863 | local FILE="${SPATH}/Sources" | |
864 | local DSCFILE="${NAME}_${VERSION}.dsc" | |
865 | local TARFILE="${NAME}_${VERSION}.tar.gz" | |
866 | echo "Package: $NAME | |
867 | Binary: $BINARY | |
868 | Version: $VERSION | |
869 | Maintainer: Joe Sixpack <joe@example.org> | |
870 | Architecture: $ARCH" >> $FILE | |
871 | test -z "$DEPENDENCIES" || echo "$DEPENDENCIES" >> "$FILE" | |
872 | echo "Files: | |
873 | $(echo -n "$DSCFILE" | md5sum | cut -d' ' -f 1) $(echo -n "$DSCFILE" | wc -c) "$DSCFILE" | |
874 | $(echo -n "$TARFILE" | md5sum | cut -d' ' -f 1) $(echo -n "$TARFILE" | wc -c) "$TARFILE" | |
875 | Checksums-Sha256: | |
876 | $(echo -n "$DSCFILE" | sha256sum | cut -d' ' -f 1) $(echo -n "$DSCFILE" | wc -c) "$DSCFILE" | |
877 | $(echo -n "$TARFILE" | sha256sum | cut -d' ' -f 1) $(echo -n "$TARFILE" | wc -c) "$TARFILE" | |
878 | " >> "$FILE" | |
879 | } | |
880 | ||
881 | insertinstalledpackage() { | |
882 | local NAME="$1" | |
883 | local ARCH="$2" | |
884 | local VERSION="$3" | |
885 | local DEPENDENCIES="$4" | |
886 | local PRIORITY="${5:-optional}" | |
887 | local STATUS="${6:-install ok installed}" | |
888 | local DESCRIPTION="${7:-"an autogenerated dummy ${NAME}=${VERSION}/installed | |
889 | If you find such a package installed on your system, | |
890 | something went horribly wrong! They are autogenerated | |
891 | und used only by testcases and surf no other propose…"}" | |
892 | ||
893 | local FILE='rootdir/var/lib/dpkg/status' | |
894 | local INFO='rootdir/var/lib/dpkg/info' | |
895 | for arch in $(getarchitecturesfromcommalist "$ARCH"); do | |
896 | echo "Package: $NAME | |
897 | Status: $STATUS | |
898 | Priority: $PRIORITY | |
899 | Section: other | |
900 | Installed-Size: 42 | |
901 | Maintainer: Joe Sixpack <joe@example.org> | |
902 | Version: $VERSION" >> "$FILE" | |
903 | test "$arch" = 'none' || echo "Architecture: $arch" >> "$FILE" | |
904 | test -z "$DEPENDENCIES" || echo "$DEPENDENCIES" >> "$FILE" | |
905 | echo "Description: $DESCRIPTION" >> "$FILE" | |
906 | echo >> "$FILE" | |
907 | if [ "$(dpkg-query -W --showformat='${Multi-Arch}')" = 'same' ]; then | |
908 | echo -n > "${INFO}/${NAME}:${arch}.list" | |
909 | else | |
910 | echo -n > "${INFO}/${NAME}.list" | |
911 | fi | |
912 | done | |
913 | } | |
914 | ||
915 | ||
916 | buildaptarchivefromincoming() { | |
917 | msginfo "Build APT archive for ${CCMD}${0##*/}${CINFO} based on incoming packages…" | |
918 | cd aptarchive | |
919 | [ -e pool ] || ln -s ../incoming pool | |
920 | [ -e ftparchive.conf ] || createaptftparchiveconfig | |
921 | [ -e dists ] || buildaptftparchivedirectorystructure | |
922 | msgninfo "\tGenerate Packages, Sources and Contents files… " | |
923 | testsuccess aptftparchive generate ftparchive.conf | |
924 | cd - > /dev/null | |
925 | msgdone "info" | |
926 | generatereleasefiles "$@" | |
927 | } | |
928 | ||
929 | buildaptarchivefromfiles() { | |
930 | msginfo "Build APT archive for ${CCMD}${0##*/}${CINFO} based on prebuild files…" | |
931 | local DIR='aptarchive' | |
932 | if [ -d "${DIR}/dists" ]; then DIR="${DIR}/dists"; fi | |
933 | find "$DIR" -name 'Packages' -o -name 'Sources' -o -name 'Translation-*' | while read line; do | |
934 | msgninfo "\t${line} file… " | |
935 | compressfile "$line" "$1" | |
936 | msgdone "info" | |
937 | done | |
938 | generatereleasefiles "$@" | |
939 | } | |
940 | ||
941 | compressfile() { | |
942 | cat "${TMPWORKINGDIRECTORY}/rootdir/etc/testcase-compressor.conf" | while read compressor extension command; do | |
943 | if [ "$compressor" = '.' ]; then | |
944 | if [ -n "$2" ]; then | |
945 | touch -d "$2" "$1" | |
946 | fi | |
947 | continue | |
948 | fi | |
949 | cat "$1" | $command > "${1}.${extension}" | |
950 | if [ -n "$2" ]; then | |
951 | touch -d "$2" "${1}.${extension}" | |
952 | fi | |
953 | done | |
954 | } | |
955 | ||
956 | # can be overridden by testcases for their pleasure | |
957 | getcodenamefromsuite() { | |
958 | case "$1" in | |
959 | unstable) echo 'sid';; | |
960 | *) echo -n "$1";; | |
961 | esac | |
962 | } | |
963 | getreleaseversionfromsuite() { true; } | |
964 | getlabelfromsuite() { true; } | |
965 | getoriginfromsuite() { true; } | |
966 | getarchitecturesfromreleasefile() { echo "all $(getarchitectures)"; } | |
967 | ||
968 | aptftparchiverelease() { | |
969 | aptftparchive -qq release "$@" | sed -e '/0 Release$/ d' # remove the self reference | |
970 | } | |
971 | generatereleasefiles() { | |
972 | # $1 is the Date header and $2 is the ValidUntil header to be set | |
973 | # both should be given in notation date/touch can understand | |
974 | local DATE="$1" | |
975 | local VALIDUNTIL="$2" | |
976 | msgninfo "\tGenerate Release files… " | |
977 | if [ -e aptarchive/dists ]; then | |
978 | for dir in $(find ./aptarchive/dists -mindepth 1 -maxdepth 1 -type d); do | |
979 | local ARCHITECTURES="$(getarchitecturesfromreleasefile "$dir")" | |
980 | local SUITE="$(echo "$dir" | cut -d'/' -f 4)" | |
981 | local CODENAME="$(getcodenamefromsuite $SUITE)" | |
982 | local VERSION="$(getreleaseversionfromsuite $SUITE)" | |
983 | local LABEL="$(getlabelfromsuite $SUITE)" | |
984 | local ORIGIN="$(getoriginfromsuite $SUITE)" | |
985 | if [ -n "$VERSION" ]; then | |
986 | VERSION="-o APT::FTPArchive::Release::Version=${VERSION}" | |
987 | fi | |
988 | if [ -n "$LABEL" ]; then | |
989 | LABEL="-o APT::FTPArchive::Release::Label=${LABEL}" | |
990 | fi | |
991 | if [ -n "$ORIGIN" ]; then | |
992 | ORIGIN="-o APT::FTPArchive::Release::Origin=${ORIGIN}" | |
993 | fi | |
994 | if [ -n "$ARCHITECTURES" ]; then | |
995 | ARCHITECTURES="-o APT::FTPArchive::Release::Architectures=${ARCHITECTURES}" | |
996 | fi | |
997 | aptftparchiverelease "$dir" \ | |
998 | -o APT::FTPArchive::Release::Suite="${SUITE}" \ | |
999 | -o APT::FTPArchive::Release::Codename="${CODENAME}" \ | |
1000 | ${ARCHITECTURES} \ | |
1001 | ${LABEL} \ | |
1002 | ${ORIGIN} \ | |
1003 | ${VERSION} \ | |
1004 | > "$dir/Release" | |
1005 | if [ "$SUITE" = "experimental" -o "$SUITE" = "experimental2" ]; then | |
1006 | sed -i '/^Date: / a\ | |
1007 | NotAutomatic: yes' "$dir/Release" | |
1008 | fi | |
1009 | done | |
1010 | else | |
1011 | aptftparchiverelease ./aptarchive > aptarchive/Release | |
1012 | fi | |
1013 | if [ -n "$DATE" -a "$DATE" != "now" ]; then | |
1014 | for release in $(find ./aptarchive -name 'Release'); do | |
1015 | sed -i "s/^Date: .*$/Date: $(date -d "$DATE" '+%a, %d %b %Y %H:%M:%S %Z')/" "$release" | |
1016 | touch -d "$DATE" "$release" | |
1017 | done | |
1018 | fi | |
1019 | if [ -n "$VALIDUNTIL" ]; then | |
1020 | sed -i "/^Date: / a\ | |
1021 | Valid-Until: $(date -d "$VALIDUNTIL" '+%a, %d %b %Y %H:%M:%S %Z')" $(find ./aptarchive -name 'Release') | |
1022 | fi | |
1023 | msgdone "info" | |
1024 | } | |
1025 | ||
1026 | setupdistsaptarchive() { | |
1027 | local APTARCHIVE="$(readlink -f ./aptarchive | sed 's# #%20#g')" | |
1028 | rm -f root/etc/apt/sources.list.d/apt-test-*-deb.list | |
1029 | rm -f root/etc/apt/sources.list.d/apt-test-*-deb-src.list | |
1030 | for DISTS in $(find ./aptarchive/dists/ -mindepth 1 -maxdepth 1 -type d | cut -d'/' -f 4); do | |
1031 | SECTIONS=$(find "./aptarchive/dists/${DISTS}/" -mindepth 1 -maxdepth 1 -type d | cut -d'/' -f 5 | tr '\n' ' ') | |
1032 | msgninfo "\tadd deb and deb-src sources.list lines for ${CCMD}${DISTS} ${SECTIONS}${CINFO}… " | |
1033 | echo "deb file://$APTARCHIVE $DISTS $SECTIONS" > "rootdir/etc/apt/sources.list.d/apt-test-${DISTS}-deb.list" | |
1034 | echo "deb-src file://$APTARCHIVE $DISTS $SECTIONS" > "rootdir/etc/apt/sources.list.d/apt-test-${DISTS}-deb-src.list" | |
1035 | msgdone "info" | |
1036 | done | |
1037 | } | |
1038 | ||
1039 | setupflataptarchive() { | |
1040 | local APTARCHIVE="$(readlink -f ./aptarchive)" | |
1041 | local APTARCHIVEURI="$(readlink -f ./aptarchive | sed 's# #%20#g')" | |
1042 | if [ -f "${APTARCHIVE}/Packages" ]; then | |
1043 | msgninfo "\tadd deb sources.list line… " | |
1044 | echo "deb file://$APTARCHIVEURI /" > 'rootdir/etc/apt/sources.list.d/apt-test-archive-deb.list' | |
1045 | msgdone 'info' | |
1046 | else | |
1047 | rm -f 'rootdir/etc/apt/sources.list.d/apt-test-archive-deb.list' | |
1048 | fi | |
1049 | if [ -f "${APTARCHIVE}/Sources" ]; then | |
1050 | msgninfo "\tadd deb-src sources.list line… " | |
1051 | echo "deb-src file://$APTARCHIVEURI /" > 'rootdir/etc/apt/sources.list.d/apt-test-archive-deb-src.list' | |
1052 | msgdone 'info' | |
1053 | else | |
1054 | rm -f 'rootdir/etc/apt/sources.list.d/apt-test-archive-deb-src.list' | |
1055 | fi | |
1056 | } | |
1057 | ||
1058 | setupaptarchive() { | |
1059 | local NOUPDATE=0 | |
1060 | if [ "$1" = '--no-update' ]; then | |
1061 | NOUPDATE=1 | |
1062 | shift | |
1063 | fi | |
1064 | buildaptarchive "$@" | |
1065 | if [ -e aptarchive/dists ]; then | |
1066 | setupdistsaptarchive | |
1067 | else | |
1068 | setupflataptarchive | |
1069 | fi | |
1070 | signreleasefiles 'Joe Sixpack' | |
1071 | if [ "1" != "$NOUPDATE" ]; then | |
1072 | testsuccess aptget update -o Debug::pkgAcquire::Worker=true -o Debug::Acquire::gpgv=true | |
1073 | fi | |
1074 | } | |
1075 | ||
1076 | signreleasefiles() { | |
1077 | local SIGNER="${1:-Joe Sixpack}" | |
1078 | local REPODIR="${2:-aptarchive}" | |
1079 | local KEY="keys/$(echo "$SIGNER" | tr 'A-Z' 'a-z' | sed 's# ##g')" | |
1080 | local GPG="aptkey --quiet --keyring ${KEY}.pub --secret-keyring ${KEY}.sec --readonly adv --batch --yes" | |
1081 | msgninfo "\tSign archive with $SIGNER key $KEY… " | |
1082 | local REXKEY='keys/rexexpired' | |
1083 | local SECEXPIREBAK="${REXKEY}.sec.bak" | |
1084 | local PUBEXPIREBAK="${REXKEY}.pub.bak" | |
1085 | if [ "${SIGNER}" = 'Rex Expired' ]; then | |
1086 | # the key is expired, so gpg doesn't allow to sign with and the --faked-system-time | |
1087 | # option doesn't exist anymore (and using faketime would add a new obscure dependency) | |
1088 | # therefore we 'temporary' make the key not expired and restore a backup after signing | |
1089 | cp "${REXKEY}.sec" "$SECEXPIREBAK" | |
1090 | cp "${REXKEY}.pub" "$PUBEXPIREBAK" | |
1091 | local SECUNEXPIRED="${REXKEY}.sec.unexpired" | |
1092 | local PUBUNEXPIRED="${REXKEY}.pub.unexpired" | |
1093 | if [ -f "$SECUNEXPIRED" ] && [ -f "$PUBUNEXPIRED" ]; then | |
1094 | cp "$SECUNEXPIRED" "${REXKEY}.sec" | |
1095 | cp "$PUBUNEXPIRED" "${REXKEY}.pub" | |
1096 | else | |
1097 | if ! printf "expire\n1w\nsave\n" | $GPG --default-key "$SIGNER" --command-fd 0 --edit-key "${SIGNER}" >setexpire.gpg 2>&1; then | |
1098 | cat setexpire.gpg | |
1099 | exit 1 | |
1100 | fi | |
1101 | cp "${REXKEY}.sec" "$SECUNEXPIRED" | |
1102 | cp "${REXKEY}.pub" "$PUBUNEXPIRED" | |
1103 | fi | |
1104 | fi | |
1105 | for RELEASE in $(find "${REPODIR}/" -name Release); do | |
1106 | $GPG --default-key "$SIGNER" --armor --detach-sign --sign --output "${RELEASE}.gpg" "${RELEASE}" | |
1107 | local INRELEASE="$(echo "${RELEASE}" | sed 's#/Release$#/InRelease#')" | |
1108 | $GPG --default-key "$SIGNER" --clearsign --output "$INRELEASE" "$RELEASE" | |
1109 | # we might have set a specific date for the Release file, so copy it | |
1110 | touch -d "$(stat --format "%y" ${RELEASE})" "${RELEASE}.gpg" "${INRELEASE}" | |
1111 | done | |
1112 | if [ -f "$SECEXPIREBAK" ] && [ -f "$PUBEXPIREBAK" ]; then | |
1113 | mv -f "$SECEXPIREBAK" "${REXKEY}.sec" | |
1114 | mv -f "$PUBEXPIREBAK" "${REXKEY}.pub" | |
1115 | fi | |
1116 | msgdone 'info' | |
1117 | } | |
1118 | ||
1119 | redatereleasefiles() { | |
1120 | local DATE="$(date -d "$1" '+%a, %d %b %Y %H:%M:%S %Z')" | |
1121 | for release in $(find aptarchive/ -name 'Release'); do | |
1122 | sed -i "s/^Date: .*$/Date: ${DATE}/" "$release" | |
1123 | touch -d "$DATE" "$release" | |
1124 | done | |
1125 | signreleasefiles "${2:-Joe Sixpack}" | |
1126 | } | |
1127 | ||
1128 | webserverconfig() { | |
1129 | local WEBSERVER="${3:-http://localhost:${APTHTTPPORT}}" | |
1130 | local NOCHECK=false | |
1131 | if [ "$1" = '--no-check' ]; then | |
1132 | NOCHECK=true | |
1133 | shift | |
1134 | fi | |
1135 | local DOWNLOG='rootdir/tmp/download-testfile.log' | |
1136 | local STATUS='downloaded/webserverconfig.status' | |
1137 | rm -f "$STATUS" "$DOWNLOG" | |
1138 | # very very basic URI encoding | |
1139 | local URI | |
1140 | if [ -n "$2" ]; then | |
1141 | msgtest "Set webserver config option '${1}' to" "$2" | |
1142 | URI="${WEBSERVER}/_config/set/$(echo "${1}" | sed -e 's/\//%2f/g')/$(echo "${2}" | sed -e 's/\//%2f/g')" | |
1143 | else | |
1144 | msgtest 'Clear webserver config option' "${1}" | |
1145 | URI="${WEBSERVER}/_config/clear/$(echo "${1}" | sed -e 's/\//%2f/g')" | |
1146 | fi | |
1147 | if downloadfile "$URI" "$STATUS" > "$DOWNLOG"; then | |
1148 | msgpass | |
1149 | else | |
1150 | local OUTPUT="${TMPWORKINGDIRECTORY}/rootdir/tmp/webserverconfig.output" | |
1151 | cat "$DOWNLOG" "$STATUS" >"$OUTPUT" 2>&1 || true | |
1152 | msgfailoutput '' "$OUTPUT" | |
1153 | fi | |
1154 | $NOCHECK || testwebserverlaststatuscode '200' | |
1155 | } | |
1156 | ||
1157 | rewritesourceslist() { | |
1158 | local APTARCHIVE="file://$(readlink -f "${TMPWORKINGDIRECTORY}/aptarchive" | sed 's# #%20#g')" | |
1159 | local APTARCHIVE2="copy://$(readlink -f "${TMPWORKINGDIRECTORY}/aptarchive" | sed 's# #%20#g')" | |
1160 | for LIST in $(find rootdir/etc/apt/sources.list.d/ -name 'apt-test-*.list'); do | |
1161 | sed -i $LIST -e "s#$APTARCHIVE#${1}#" -e "s#$APTARCHIVE2#${1}#" \ | |
1162 | -e "s#http://localhost:${APTHTTPPORT}/#${1}#" \ | |
1163 | -e "s#https://localhost:${APTHTTPSPORT}/#${1}#" | |
1164 | done | |
1165 | } | |
1166 | ||
1167 | # wait for up to 10s for a pid file to appear to avoid possible race | |
1168 | # when a helper is started and dosn't write the PID quick enough | |
1169 | waitforpidfile() { | |
1170 | local PIDFILE="$1" | |
1171 | for i in $(seq 10); do | |
1172 | if test -s "$PIDFILE"; then | |
1173 | return 0 | |
1174 | fi | |
1175 | sleep 1 | |
1176 | done | |
1177 | msgdie "waiting for $PIDFILE failed" | |
1178 | return 1 | |
1179 | } | |
1180 | ||
1181 | changetowebserver() { | |
1182 | local REWRITE='no' | |
1183 | if [ "$1" != '--no-rewrite' ]; then | |
1184 | REWRITE='yes' | |
1185 | else | |
1186 | shift | |
1187 | fi | |
1188 | if test -x "${APTWEBSERVERBINDIR}/aptwebserver"; then | |
1189 | cd aptarchive | |
1190 | local LOG="webserver.log" | |
1191 | if ! aptwebserver --port 0 -o aptwebserver::fork=1 -o aptwebserver::portfile='aptwebserver.port' "$@" >$LOG 2>&1 ; then | |
1192 | cat $LOG | |
1193 | false | |
1194 | fi | |
1195 | waitforpidfile aptwebserver.pid | |
1196 | local PID="$(cat aptwebserver.pid)" | |
1197 | if [ -z "$PID" ]; then | |
1198 | msgdie 'Could not fork aptwebserver successfully' | |
1199 | fi | |
1200 | addtrap "kill $PID;" | |
1201 | waitforpidfile aptwebserver.port | |
1202 | APTHTTPPORT="$(cat aptwebserver.port)" | |
1203 | if [ -z "$APTHTTPPORT" ]; then | |
1204 | msgdie 'Could not get port for aptwebserver successfully' | |
1205 | fi | |
1206 | cd - > /dev/null | |
1207 | else | |
1208 | msgdie 'You have to build aptwerbserver or install a webserver' | |
1209 | fi | |
1210 | if [ "$REWRTE" != 'yes' ]; then | |
1211 | rewritesourceslist "http://localhost:${APTHTTPPORT}/" | |
1212 | fi | |
1213 | } | |
1214 | ||
1215 | changetohttpswebserver() { | |
1216 | if ! which stunnel4 >/dev/null; then | |
1217 | msgdie 'You need to install stunnel4 for https testcases' | |
1218 | fi | |
1219 | if [ ! -e "${TMPWORKINGDIRECTORY}/aptarchive/aptwebserver.pid" ]; then | |
1220 | changetowebserver --no-rewrite "$@" | |
1221 | fi | |
1222 | echo "pid = ${TMPWORKINGDIRECTORY}/aptarchive/stunnel.pid | |
1223 | cert = ${TMPWORKINGDIRECTORY}/rootdir/etc/webserver.pem | |
1224 | output = /dev/null | |
1225 | ||
1226 | [https] | |
1227 | accept = 0 | |
1228 | connect = $APTHTTPPORT | |
1229 | " > "${TMPWORKINGDIRECTORY}/stunnel.conf" | |
1230 | stunnel4 "${TMPWORKINGDIRECTORY}/stunnel.conf" | |
1231 | waitforpidfile "${TMPWORKINGDIRECTORY}/aptarchive/stunnel.pid" | |
1232 | local PID="$(cat "${TMPWORKINGDIRECTORY}/aptarchive/stunnel.pid")" | |
1233 | if [ -z "$PID" ]; then | |
1234 | msgdie 'Could not fork stunnel4 successfully' | |
1235 | fi | |
1236 | addtrap 'prefix' "kill ${PID};" | |
1237 | APTHTTPSPORT="$(lsof -i | awk "/^stunnel4 / && \$2 == \"${PID}\" {print \$9; exit; }" | cut -d':' -f 2)" | |
1238 | webserverconfig 'aptwebserver::port::https' "$APTHTTPSPORT" "https://localhost:${APTHTTPSPORT}" | |
1239 | rewritesourceslist "https://localhost:${APTHTTPSPORT}/" | |
1240 | } | |
1241 | ||
1242 | changetocdrom() { | |
1243 | mkdir -p rootdir/media/cdrom/.disk | |
1244 | local CD="$(readlink -f rootdir/media/cdrom)" | |
1245 | cat > rootdir/etc/apt/apt.conf.d/00cdrom <<EOF | |
1246 | acquire::cdrom::mount "${CD}"; | |
1247 | acquire::cdrom::"${CD}/"::mount "mv ${CD}-unmounted ${CD}"; | |
1248 | acquire::cdrom::"${CD}/"::umount "mv ${CD} ${CD}-unmounted"; | |
1249 | acquire::cdrom::autodetect 0; | |
1250 | EOF | |
1251 | echo -n "$1" > "${CD}/.disk/info" | |
1252 | if [ ! -d aptarchive/dists ]; then | |
1253 | msgdie 'Flat file archive cdroms can not be created currently' | |
1254 | return 1 | |
1255 | fi | |
1256 | mv aptarchive/dists "$CD" | |
1257 | ln -s "$(readlink -f ./incoming)" "$CD/pool" | |
1258 | find rootdir/etc/apt/sources.list.d/ -name 'apt-test-*.list' -delete | |
1259 | # start with an unmounted disk | |
1260 | mv "${CD}" "${CD}-unmounted" | |
1261 | # we don't want the disk to be modifiable | |
1262 | addtrap 'prefix' "chmod -f -R +w \"$PWD/rootdir/media/cdrom/dists/\" \"$PWD/rootdir/media/cdrom-unmounted/dists/\" || true;" | |
1263 | chmod -R 555 rootdir/media/cdrom-unmounted/dists | |
1264 | } | |
1265 | ||
1266 | downloadfile() { | |
1267 | local PROTO="${1%%:*}" | |
1268 | if ! apthelper -o Debug::Acquire::${PROTO}=1 -o Debug::pkgAcquire::Worker=1 \ | |
1269 | download-file "$1" "$2" "$3" 2>&1 ; then | |
1270 | return 1 | |
1271 | fi | |
1272 | # only if the file exists the download was successful | |
1273 | if [ -r "$2" ]; then | |
1274 | return 0 | |
1275 | else | |
1276 | return 1 | |
1277 | fi | |
1278 | } | |
1279 | ||
1280 | checkdiff() { | |
1281 | local DIFFTEXT="$(command diff -u "$@" 2>&1 | sed -e '/^---/ d' -e '/^+++/ d' -e '/^@@/ d')" | |
1282 | if [ -n "$DIFFTEXT" ]; then | |
1283 | echo >&2 | |
1284 | echo >&2 "$DIFFTEXT" | |
1285 | return 1 | |
1286 | else | |
1287 | return 0 | |
1288 | fi | |
1289 | } | |
1290 | ||
1291 | testoutputequal() { | |
1292 | local OUTPUT="${TMPWORKINGDIRECTORY}/rootdir/tmp/testoutputequal.output" | |
1293 | local COMPAREFILE="$1" | |
1294 | shift | |
1295 | if "$@" 2>&1 | checkdiff "$COMPAREFILE" - >"$OUTPUT" 2>&1; then | |
1296 | msgpass | |
1297 | else | |
1298 | echo "=== content of file we compared with (${COMPAREFILE}) ===" >>"${OUTPUT}" | |
1299 | cat "$COMPAREFILE" >>"${OUTPUT}" | |
1300 | msgfailoutput '' "$OUTPUT" "$@" | |
1301 | fi | |
1302 | } | |
1303 | ||
1304 | testfileequal() { | |
1305 | msggroup 'testfileequal' | |
1306 | local MSG='Test for correctness of file' | |
1307 | if [ "$1" = '--nomsg' ]; then | |
1308 | MSG='' | |
1309 | shift | |
1310 | fi | |
1311 | local FILE="$1" | |
1312 | shift | |
1313 | if [ -n "$MSG" ]; then | |
1314 | msgtest "$MSG" "$FILE" | |
1315 | fi | |
1316 | local OUTPUT="${TMPWORKINGDIRECTORY}/rootdir/tmp/testfileequal.output" | |
1317 | if [ -z "$*" ]; then | |
1318 | testoutputequal "$FILE" echo -n '' | |
1319 | else | |
1320 | testoutputequal "$FILE" echo "$*" | |
1321 | fi | |
1322 | msggroup | |
1323 | } | |
1324 | ||
1325 | testempty() { | |
1326 | msggroup 'testempty' | |
1327 | msgtest "Test for no output of" "$*" | |
1328 | local COMPAREFILE="${TMPWORKINGDIRECTORY}/rootdir/tmp/testempty.comparefile" | |
1329 | if ("$@" >"$COMPAREFILE" 2>&1 || true) && test ! -s "$COMPAREFILE"; then | |
1330 | msgpass | |
1331 | else | |
1332 | msgfailoutput '' "$COMPAREFILE" "$@" | |
1333 | fi | |
1334 | aptautotest 'testempty' "$@" | |
1335 | msggroup | |
1336 | } | |
1337 | testnotempty() { | |
1338 | msggroup 'testnotempty' | |
1339 | msgtest "Test for some output of" "$*" | |
1340 | local COMPAREFILE="${TMPWORKINGDIRECTORY}/rootdir/tmp/testnotempty.comparefile" | |
1341 | if ("$@" >"$COMPAREFILE" 2>&1 || true) && test -s "$COMPAREFILE"; then | |
1342 | msgpass | |
1343 | else | |
1344 | msgfailoutput '' "$COMPAREFILE" "$@" | |
1345 | fi | |
1346 | aptautotest 'testnotempty' "$@" | |
1347 | msggroup | |
1348 | } | |
1349 | ||
1350 | testequal() { | |
1351 | msggroup 'testequal' | |
1352 | local MSG='Test of equality of' | |
1353 | if [ "$1" = '--nomsg' ]; then | |
1354 | MSG='' | |
1355 | shift | |
1356 | fi | |
1357 | ||
1358 | local COMPAREFILE="${TMPWORKINGDIRECTORY}/rootdir/tmp/testequal.comparefile" | |
1359 | echo "$1" > "$COMPAREFILE" | |
1360 | shift | |
1361 | ||
1362 | if [ -n "$MSG" ]; then | |
1363 | msgtest "$MSG" "$*" | |
1364 | fi | |
1365 | testoutputequal "$COMPAREFILE" "$@" | |
1366 | aptautotest 'testequal' "$@" | |
1367 | msggroup | |
1368 | } | |
1369 | ||
1370 | testequalor2() { | |
1371 | msggroup 'testequalor2' | |
1372 | local COMPAREFILE1="${TMPWORKINGDIRECTORY}/rootdir/tmp/testequalor2.comparefile1" | |
1373 | local COMPAREFILE2="${TMPWORKINGDIRECTORY}/rootdir/tmp/testequalor2.comparefile2" | |
1374 | local COMPAREAGAINST="${TMPWORKINGDIRECTORY}/rootdir/tmp/testequalor2.compareagainst" | |
1375 | echo "$1" > "$COMPAREFILE1" | |
1376 | echo "$2" > "$COMPAREFILE2" | |
1377 | shift 2 | |
1378 | msgtest "Test for equality OR of" "$*" | |
1379 | "$@" >"$COMPAREAGAINST" 2>&1 || true | |
1380 | if checkdiff "$COMPAREFILE1" "$COMPAREAGAINST" >/dev/null 2>&1 || \ | |
1381 | checkdiff "$COMPAREFILE2" "$COMPAREAGAINST" >/dev/null 2>&1 | |
1382 | then | |
1383 | msgpass | |
1384 | else | |
1385 | local OUTPUT="${TMPWORKINGDIRECTORY}/rootdir/tmp/testequal.output" | |
1386 | echo -n "\n${CINFO}Diff against OR 1${CNORMAL}" >"$OUTPUT" 2>&1 | |
1387 | checkdiff "$COMPAREFILE1" "$COMPAREAGAINST" >"$OUTPUT" 2>&1 || true | |
1388 | echo -n "${CINFO}Diff against OR 2${CNORMAL}" >"$OUTPUT" 2>&1 | |
1389 | checkdiff "$COMPAREFILE2" "$COMPAREAGAINST" >"$OUTPUT" 2>&1 || true | |
1390 | msgfailoutput '' "$OUTPUT" | |
1391 | fi | |
1392 | aptautotest 'testequalor2' "$@" | |
1393 | msggroup | |
1394 | } | |
1395 | ||
1396 | testshowvirtual() { | |
1397 | msggroup 'testshowvirtual' | |
1398 | local VIRTUAL="N: Can't select versions from package '$1' as it is purely virtual" | |
1399 | local PACKAGE="$1" | |
1400 | shift | |
1401 | while [ -n "$1" ]; do | |
1402 | VIRTUAL="${VIRTUAL} | |
1403 | N: Can't select versions from package '$1' as it is purely virtual" | |
1404 | PACKAGE="${PACKAGE} $1" | |
1405 | shift | |
1406 | done | |
1407 | msgtest "Test for virtual packages" "apt-cache show $PACKAGE" | |
1408 | VIRTUAL="${VIRTUAL} | |
1409 | N: No packages found" | |
1410 | local COMPAREFILE="${TMPWORKINGDIRECTORY}/rootdir/tmp/testshowvirtual.comparefile" | |
1411 | local ARCH="$(getarchitecture 'native')" | |
1412 | echo "$VIRTUAL" | sed -e "s/:$ARCH//" -e 's/:all//' >"$COMPAREFILE" | |
1413 | local OUTPUT="${TMPWORKINGDIRECTORY}/rootdir/tmp/testshowvirtual.output" | |
1414 | testoutputequal "$COMPAREFILE" aptcache show -q=0 "$PACKAGE" | |
1415 | msggroup | |
1416 | } | |
1417 | ||
1418 | testnopackage() { | |
1419 | msggroup 'testnopackage' | |
1420 | msgtest "Test for non-existent packages" "apt-cache show $*" | |
1421 | local SHOWPKG="$(aptcache show "$@" 2>&1 | grep '^Package: ')" | |
1422 | if [ -n "$SHOWPKG" ]; then | |
1423 | local OUTPUT="${TMPWORKINGDIRECTORY}/rootdir/tmp/testnopackage.output" | |
1424 | echo "$SHOWPKG" >"$OUTPUT" | |
1425 | msgfailoutput '' "$OUTPUT" | |
1426 | else | |
1427 | msgpass | |
1428 | fi | |
1429 | msggroup | |
1430 | } | |
1431 | ||
1432 | testdpkgstatus() { | |
1433 | msggroup 'testdpkgstatus' | |
1434 | local STATE="$1" | |
1435 | local NR="$2" | |
1436 | shift 2 | |
1437 | msgtest "Test that $NR package(s) are in state $STATE with" "dpkg -l $*" | |
1438 | local PKGS="$(dpkg -l "$@" 2>/dev/null | grep "^${STATE}" | wc -l)" | |
1439 | if [ "$PKGS" != $NR ]; then | |
1440 | local OUTPUT="${TMPWORKINGDIRECTORY}/rootdir/tmp/testnopackage.output" | |
1441 | echo "$PKGS" >"$OUTPUT" | |
1442 | dpkg -l "$@" | grep '^[a-z]' >"$OUTPUT" >&2 || true | |
1443 | msgfailoutput '' "$OUTPUT" | |
1444 | else | |
1445 | msgpass | |
1446 | fi | |
1447 | msggroup | |
1448 | } | |
1449 | ||
1450 | testdpkginstalled() { | |
1451 | msggroup 'testdpkginstalled' | |
1452 | testdpkgstatus 'ii' "$#" "$@" | |
1453 | msggroup | |
1454 | } | |
1455 | ||
1456 | testdpkgnotinstalled() { | |
1457 | msggroup 'testdpkgnotinstalled' | |
1458 | testdpkgstatus 'ii' '0' "$@" | |
1459 | msggroup | |
1460 | } | |
1461 | ||
1462 | testmarkedauto() { | |
1463 | msggroup 'testmarkedauto' | |
1464 | local COMPAREFILE="${TMPWORKINGDIRECTORY}/rootdir/tmp/testmarkedauto.comparefile" | |
1465 | if [ -n "$1" ]; then | |
1466 | msgtest 'Test for correctly marked as auto-installed' "$*" | |
1467 | while [ -n "$1" ]; do echo "$1"; shift; done | sort > "$COMPAREFILE" | |
1468 | else | |
1469 | msgtest 'Test for correctly marked as auto-installed' 'no package' | |
1470 | echo -n > "$COMPAREFILE" | |
1471 | fi | |
1472 | testoutputequal "$COMPAREFILE" aptmark showauto | |
1473 | msggroup | |
1474 | } | |
1475 | testmarkedmanual() { | |
1476 | msggroup 'testmarkedmanual' | |
1477 | local COMPAREFILE="${TMPWORKINGDIRECTORY}/rootdir/tmp/testmarkedmanual.comparefile" | |
1478 | if [ -n "$1" ]; then | |
1479 | msgtest 'Test for correctly marked as manually installed' "$*" | |
1480 | while [ -n "$1" ]; do echo "$1"; shift; done | sort > "$COMPAREFILE" | |
1481 | else | |
1482 | msgtest 'Test for correctly marked as manually installed' 'no package' | |
1483 | echo -n > "$COMPAREFILE" | |
1484 | fi | |
1485 | testoutputequal "$COMPAREFILE" aptmark showmanual | |
1486 | msggroup | |
1487 | } | |
1488 | ||
1489 | msgfailoutput() { | |
1490 | msgreportheader 'msgfailoutput' | |
1491 | local MSG="$1" | |
1492 | local OUTPUT="$2" | |
1493 | shift 2 | |
1494 | if [ "$1" = 'grep' ]; then | |
1495 | echo >&2 | |
1496 | while [ -n "$2" ]; do shift; done | |
1497 | echo "#### Complete file: $1 ####" | |
1498 | cat >&2 "$1" || true | |
1499 | echo '#### grep output ####' | |
1500 | elif [ "$1" = 'test' ]; then | |
1501 | echo >&2 | |
1502 | # doesn't support ! or non-file flags | |
1503 | msgfailoutputstatfile() { | |
1504 | local FILEFLAGS='^-[bcdefgGhkLOprsStuwx]$' | |
1505 | if expr match "$1" "$FILEFLAGS" >/dev/null; then | |
1506 | echo "#### stat(2) of file: $2 ####" | |
1507 | stat "$2" || true | |
1508 | if test -e "$2"; then | |
1509 | echo "#### Complete file: $2 ####" | |
1510 | cat >&2 "$2" || true | |
1511 | fi | |
1512 | fi | |
1513 | } | |
1514 | msgfailoutputstatfile "$2" "$3" | |
1515 | while [ -n "$5" ] && [ "$4" = '-o' -o "$4" = '-a' ]; do | |
1516 | shift 3 | |
1517 | msgfailoutputstatfile "$2" "$3" | |
1518 | done | |
1519 | echo '#### test output ####' | |
1520 | fi | |
1521 | cat >&2 "$OUTPUT" | |
1522 | msgfail "$MSG" | |
1523 | } | |
1524 | ||
1525 | testsuccess() { | |
1526 | msggroup 'testsuccess' | |
1527 | if [ "$1" = '--nomsg' ]; then | |
1528 | shift | |
1529 | else | |
1530 | msgtest 'Test for successful execution of' "$*" | |
1531 | fi | |
1532 | local OUTPUT="${TMPWORKINGDIRECTORY}/rootdir/tmp/testsuccess.output" | |
1533 | if "$@" >"${OUTPUT}" 2>&1; then | |
1534 | if expr match "$1" '^apt.*' >/dev/null; then | |
1535 | if grep -q -E ' runtime error: ' "$OUTPUT"; then | |
1536 | msgfailoutput 'compiler detected undefined behavior' "$OUTPUT" "$@" | |
1537 | elif grep -E '^[WE]: ' "$OUTPUT" > "${TMPWORKINGDIRECTORY}/rootdir/tmp/checkforwarnings.output" 2>&1; then | |
1538 | if [ "$IGNORE_PTY_NOT_MOUNTED" = '1' ]; then | |
1539 | if echo 'E: Can not write log (Is /dev/pts mounted?) - posix_openpt (2: No such file or directory)' \ | |
1540 | | cmp - "${TMPWORKINGDIRECTORY}/rootdir/tmp/checkforwarnings.output" >/dev/null 2>&1; then | |
1541 | msgpass | |
1542 | else | |
1543 | msgfailoutput 'successful run, but output contains warnings/errors' "$OUTPUT" "$@" | |
1544 | fi | |
1545 | else | |
1546 | msgfailoutput 'successful run, but output contains warnings/errors' "$OUTPUT" "$@" | |
1547 | fi | |
1548 | else | |
1549 | msgpass | |
1550 | fi | |
1551 | else | |
1552 | msgpass | |
1553 | fi | |
1554 | else | |
1555 | local EXITCODE=$? | |
1556 | msgfailoutput "exitcode $EXITCODE" "$OUTPUT" "$@" | |
1557 | fi | |
1558 | aptautotest 'testsuccess' "$@" | |
1559 | msggroup | |
1560 | } | |
1561 | testwarning() { | |
1562 | msggroup 'testwarning' | |
1563 | if [ "$1" = '--nomsg' ]; then | |
1564 | shift | |
1565 | else | |
1566 | msgtest 'Test for successful execution with warnings of' "$*" | |
1567 | fi | |
1568 | local OUTPUT="${TMPWORKINGDIRECTORY}/rootdir/tmp/testwarning.output" | |
1569 | if "$@" >"${OUTPUT}" 2>&1; then | |
1570 | if expr match "$1" '^apt.*' >/dev/null; then | |
1571 | if grep -q -E ' runtime error: ' "$OUTPUT"; then | |
1572 | msgfailoutput 'compiler detected undefined behavior' "$OUTPUT" "$@" | |
1573 | elif grep -q -E '^E: ' "$OUTPUT"; then | |
1574 | msgfailoutput 'successful run, but output contains errors' "$OUTPUT" "$@" | |
1575 | elif ! grep -q -E '^W: ' "$OUTPUT"; then | |
1576 | msgfailoutput 'successful run, but output contains no warnings' "$OUTPUT" "$@" | |
1577 | else | |
1578 | msgpass | |
1579 | fi | |
1580 | else | |
1581 | msgpass | |
1582 | fi | |
1583 | else | |
1584 | local EXITCODE=$? | |
1585 | msgfailoutput "exitcode $EXITCODE" "$OUTPUT" "$@" | |
1586 | fi | |
1587 | aptautotest 'testwarning' "$@" | |
1588 | msggroup | |
1589 | } | |
1590 | testfailure() { | |
1591 | msggroup 'testfailure' | |
1592 | if [ "$1" = '--nomsg' ]; then | |
1593 | shift | |
1594 | else | |
1595 | msgtest 'Test for failure in execution of' "$*" | |
1596 | fi | |
1597 | local OUTPUT="${TMPWORKINGDIRECTORY}/rootdir/tmp/testfailure.output" | |
1598 | if "$@" >"${OUTPUT}" 2>&1; then | |
1599 | local EXITCODE=$? | |
1600 | msgfailoutput "exitcode $EXITCODE" "$OUTPUT" "$@" | |
1601 | else | |
1602 | local EXITCODE=$? | |
1603 | if expr match "$1" '^apt.*' >/dev/null; then | |
1604 | if [ "$1" = 'aptkey' ]; then | |
1605 | if grep -q -E " Can't check signature: " "$OUTPUT" || \ | |
1606 | grep -q -E " BAD signature from " "$OUTPUT"; then | |
1607 | msgpass | |
1608 | else | |
1609 | msgfailoutput "run failed with exitcode ${EXITCODE}, but no signature error" "$OUTPUT" "$@" | |
1610 | fi | |
1611 | else | |
1612 | if grep -q -E ' runtime error: ' "$OUTPUT"; then | |
1613 | msgfailoutput 'compiler detected undefined behavior' "$OUTPUT" "$@" | |
1614 | elif grep -q -E '==ERROR' "$OUTPUT"; then | |
1615 | msgfailoutput 'compiler sanitizers reported errors' "$OUTPUT" "$@" | |
1616 | elif ! grep -q -E '^E: ' "$OUTPUT"; then | |
1617 | msgfailoutput "run failed with exitcode ${EXITCODE}, but with no errors" "$OUTPUT" "$@" | |
1618 | else | |
1619 | msgpass | |
1620 | fi | |
1621 | fi | |
1622 | else | |
1623 | msgpass | |
1624 | fi | |
1625 | fi | |
1626 | aptautotest 'testfailure' "$@" | |
1627 | msggroup | |
1628 | } | |
1629 | ||
1630 | testreturnstateequal() { | |
1631 | local STATE="$1" | |
1632 | msggroup "${STATE}equal" | |
1633 | if [ "$2" != '--nomsg' ]; then | |
1634 | local CMP="$2" | |
1635 | shift 2 | |
1636 | "$STATE" "$@" | |
1637 | testfileequal "${TMPWORKINGDIRECTORY}/rootdir/tmp/${STATE}.output" "$CMP" | |
1638 | else | |
1639 | local CMP="$3" | |
1640 | shift 3 | |
1641 | "$STATE" --nomsg "$@" | |
1642 | testfileequal "${TMPWORKINGDIRECTORY}/rootdir/tmp/${STATE}.output" "$CMP" | |
1643 | fi | |
1644 | msggroup | |
1645 | } | |
1646 | testsuccessequal() { | |
1647 | testreturnstateequal 'testsuccess' "$@" | |
1648 | } | |
1649 | testwarningequal() { | |
1650 | testreturnstateequal 'testwarning' "$@" | |
1651 | } | |
1652 | testfailureequal() { | |
1653 | testreturnstateequal 'testfailure' "$@" | |
1654 | } | |
1655 | ||
1656 | testfailuremsg() { | |
1657 | msggroup 'testfailuremsg' | |
1658 | local CMP="$1" | |
1659 | shift | |
1660 | testfailure "$@" | |
1661 | msgtest 'Check that the output of the previous failed command has expected' 'failures and warnings' | |
1662 | local COMPAREFILE="${TMPWORKINGDIRECTORY}/rootdir/tmp/testfailuremsg.comparefile" | |
1663 | grep '^\(W\|E\|N\):' "${TMPWORKINGDIRECTORY}/rootdir/tmp/testfailure.output" > "$COMPAREFILE" 2>&1 || true | |
1664 | testoutputequal "$COMPAREFILE" echo "$CMP" | |
1665 | msggroup | |
1666 | } | |
1667 | testwarningmsg() { | |
1668 | msggroup 'testwarningmsg' | |
1669 | local CMP="$1" | |
1670 | shift | |
1671 | testwarning "$@" | |
1672 | msgtest 'Check that the output of the previous warned command has expected' 'warnings' | |
1673 | local COMPAREFILE="${TMPWORKINGDIRECTORY}/rootdir/tmp/testwarningmsg.comparefile" | |
1674 | grep '^\(W\|E\|N\):' "${TMPWORKINGDIRECTORY}/rootdir/tmp/testwarning.output" > "$COMPAREFILE" 2>&1 || true | |
1675 | testoutputequal "$COMPAREFILE" echo "$CMP" | |
1676 | msggroup | |
1677 | } | |
1678 | ||
1679 | testfilestats() { | |
1680 | msggroup 'testfilestats' | |
1681 | msgtest "Test that file $1 has $2 $3" "$4" | |
1682 | if [ "$4" "$3" "$(stat --format "$2" "$1")" ]; then | |
1683 | msgpass | |
1684 | else | |
1685 | local OUTPUT="${TMPWORKINGDIRECTORY}/rootdir/tmp/testfilestats.output" | |
1686 | { | |
1687 | ls -ld "$1" || true | |
1688 | echo -n "stat(1) reports for $2: " | |
1689 | stat --format "$2" "$1" || true | |
1690 | } >"$OUTPUT" 2>&1 | |
1691 | msgfailoutput '' "$OUTPUT" | |
1692 | fi | |
1693 | msggroup | |
1694 | } | |
1695 | testaccessrights() { | |
1696 | msggroup 'testaccessrights' | |
1697 | testfilestats "$1" '%a' '=' "$2" | |
1698 | msggroup | |
1699 | } | |
1700 | ||
1701 | testwebserverlaststatuscode() { | |
1702 | msggroup 'testwebserverlaststatuscode' | |
1703 | local DOWNLOG='rootdir/tmp/webserverstatus-testfile.log' | |
1704 | local STATUS='downloaded/webserverstatus-statusfile.log' | |
1705 | rm -f "$DOWNLOG" "$STATUS" | |
1706 | msgtest 'Test last status code from the webserver was' "$1" | |
1707 | if downloadfile "http://localhost:${APTHTTPPORT}/_config/find/aptwebserver::last-status-code" "$STATUS" > "$DOWNLOG" && [ "$(cat "$STATUS")" = "$1" ]; then | |
1708 | msgpass | |
1709 | else | |
1710 | local OUTPUT="${TMPWORKINGDIRECTORY}/rootdir/tmp/testwebserverlaststatuscode.output" | |
1711 | { | |
1712 | if [ -n "$2" ]; then | |
1713 | shift | |
1714 | echo >&2 '#### Additionally provided output files contain:' | |
1715 | cat >&2 "$@" | |
1716 | fi | |
1717 | echo >&2 '#### Download log of the status code:' | |
1718 | cat >&2 "$DOWNLOG" | |
1719 | } >"$OUTPUT" 2>&1 | |
1720 | msgfailoutput "Status was $(cat "$STATUS")" "$OUTPUT" | |
1721 | fi | |
1722 | msggroup | |
1723 | } | |
1724 | ||
1725 | pause() { | |
1726 | echo "STOPPED execution. Press enter to continue" | |
1727 | local IGNORE | |
1728 | read IGNORE | |
1729 | } | |
1730 | ||
1731 | listcurrentlistsdirectory() { | |
1732 | { | |
1733 | find rootdir/var/lib/apt/lists -maxdepth 1 -type d | while read line; do | |
1734 | stat --format '%U:%G:%a:%n' "$line" | |
1735 | done | |
1736 | find rootdir/var/lib/apt/lists -maxdepth 1 \! -type d | while read line; do | |
1737 | stat --format '%U:%G:%a:%s:%y:%n' "$line" | |
1738 | done | |
1739 | } | sort | |
1740 | } | |
1741 | ||
1742 | ### convenience hacks ### | |
1743 | mkdir() { | |
1744 | # creating some directories by hand is a tedious task, so make it look simple | |
1745 | if [ "$*" = '-p rootdir/var/lib/apt/lists' ] || [ "$*" = "${TMPWORKINGDIRECTORY}/rootdir/var/lib/apt/lists" ] || | |
1746 | [ "$*" = '-p rootdir/var/lib/apt/lists/partial' ] || [ "$*" = "${TMPWORKINGDIRECTORY}/rootdir/var/lib/apt/lists/partial" ]; then | |
1747 | # only the last directory created by mkdir is effected by the -m ! | |
1748 | command mkdir -m 755 -p "${TMPWORKINGDIRECTORY}/rootdir/var/lib/apt" | |
1749 | command mkdir -m 755 -p "${TMPWORKINGDIRECTORY}/rootdir/var/lib/apt/lists" | |
1750 | command mkdir -m 700 -p "${TMPWORKINGDIRECTORY}/rootdir/var/lib/apt/lists/partial" | |
1751 | touch "${TMPWORKINGDIRECTORY}/rootdir/var/lib/apt/lists/lock" | |
1752 | if [ "$(id -u)" = '0' ]; then | |
1753 | chown _apt:root "${TMPWORKINGDIRECTORY}/rootdir/var/lib/apt/lists/partial" | |
1754 | fi | |
1755 | else | |
1756 | command mkdir "$@" | |
1757 | fi | |
1758 | } | |
1759 | ||
1760 | ### The following tests are run by most test methods automatically to check | |
1761 | ### general things about commands executed without writing the test every time. | |
1762 | ||
1763 | aptautotest() { | |
1764 | local TESTCALL="$1" | |
1765 | local CMD="$2" | |
1766 | local FIRSTOPT="$3" | |
1767 | local AUTOTEST="aptautotest_$(echo "${CMD##*/}_${FIRSTOPT}" | tr -d '-')" | |
1768 | if command -v $AUTOTEST >/dev/null; then | |
1769 | shift 3 | |
1770 | # save and restore the *.output files from other tests | |
1771 | # as we might otherwise override them in these automatic tests | |
1772 | rm -rf "${TMPWORKINGDIRECTORY}/rootdir/tmp-before" | |
1773 | mv "${TMPWORKINGDIRECTORY}/rootdir/tmp" "${TMPWORKINGDIRECTORY}/rootdir/tmp-before" | |
1774 | mkdir "${TMPWORKINGDIRECTORY}/rootdir/tmp" | |
1775 | $AUTOTEST "$TESTCALL" "$@" | |
1776 | rm -rf "${TMPWORKINGDIRECTORY}/rootdir/tmp-aptautotest" | |
1777 | mv "${TMPWORKINGDIRECTORY}/rootdir/tmp" "${TMPWORKINGDIRECTORY}/rootdir/tmp-aptautotest" | |
1778 | mv "${TMPWORKINGDIRECTORY}/rootdir/tmp-before" "${TMPWORKINGDIRECTORY}/rootdir/tmp" | |
1779 | fi | |
1780 | } | |
1781 | ||
1782 | aptautotest_aptget_update() { | |
1783 | local TESTCALL="$1" | |
1784 | while [ -n "$2" ]; do | |
1785 | if [ "$2" = '--print-uris' ]; then return; fi # simulation mode | |
1786 | shift | |
1787 | done | |
1788 | if ! test -d "${TMPWORKINGDIRECTORY}/rootdir/var/lib/apt/lists"; then return; fi | |
1789 | testfilestats "${TMPWORKINGDIRECTORY}/rootdir/var/lib/apt" '%U:%G:%a' '=' "${TEST_DEFAULT_USER}:${TEST_DEFAULT_GROUP}:755" | |
1790 | testfilestats "${TMPWORKINGDIRECTORY}/rootdir/var/lib/apt/lists" '%U:%G:%a' '=' "${TEST_DEFAULT_USER}:${TEST_DEFAULT_GROUP}:755" | |
1791 | # all copied files are properly chmodded | |
1792 | local backupIFS="$IFS" | |
1793 | IFS="$(printf "\n\b")" | |
1794 | for file in $(find "${TMPWORKINGDIRECTORY}/rootdir/var/lib/apt/lists" -type f ! -name 'lock'); do | |
1795 | testfilestats "$file" '%U:%G:%a' '=' "${TEST_DEFAULT_USER}:${TEST_DEFAULT_GROUP}:644" | |
1796 | done | |
1797 | IFS="$backupIFS" | |
1798 | if [ "$TESTCALL" = 'testsuccess' ]; then | |
1799 | # failure cases can retain partial files and such | |
1800 | testempty find "${TMPWORKINGDIRECTORY}/rootdir/var/lib/apt/lists/partial" -mindepth 1 ! \( -name 'lock' -o -name '*.FAILED' \) | |
1801 | fi | |
1802 | } | |
1803 | aptautotest_apt_update() { aptautotest_aptget_update "$@"; } | |
1804 | aptautotest_aptcdrom_add() { aptautotest_aptget_update "$@"; } | |
1805 | ||
1806 | testaptautotestnodpkgwarning() { | |
1807 | local TESTCALL="$1" | |
1808 | while [ -n "$2" ]; do | |
1809 | if expr match "$2" '^-[a-z]*s' >/dev/null 2>&1; then return; fi # simulation mode | |
1810 | if expr match "$2" '^-dy\?' >/dev/null 2>&1; then return; fi # download-only mode | |
1811 | shift | |
1812 | done | |
1813 | testfailure grep '^dpkg: warning:.*ignor.*' "${TMPWORKINGDIRECTORY}/rootdir/tmp-before/${TESTCALL}.output" | |
1814 | } | |
1815 | ||
1816 | aptautotest_aptget_install() { testaptautotestnodpkgwarning "$@"; } | |
1817 | aptautotest_aptget_remove() { testaptautotestnodpkgwarning "$@"; } | |
1818 | aptautotest_aptget_purge() { testaptautotestnodpkgwarning "$@"; } | |
1819 | aptautotest_apt_install() { testaptautotestnodpkgwarning "$@"; } | |
1820 | aptautotest_apt_remove() { testaptautotestnodpkgwarning "$@"; } | |
1821 | aptautotest_apt_purge() { testaptautotestnodpkgwarning "$@"; } |